import es
import gamethread
import playerlib
import shelve
import gamethread
import random
import popuplib
import time
import string
import psyco
from es import server_var
from wcs import wcs

info = es.AddonInfo()
info.name = 'Warcraft Enhanced'
info.version = '1.3.15'
info.basename = 'WCE'
info.url = 'None ATM'
info.author = 'Largo Usagi'

global wceAdminsSteamid
global wcedata
global bank
global donaterList
global debugMode
debugMode = 'False'
wcedata = shelve.open(es.getAddonPath('wce') + '/data/wcedata.db', writeback=True)
bank = shelve.open(es.getAddonPath('wce') + '/data/bank.db', writeback=True)
ranked = shelve.open(es.getAddonPath('wce') + '/data/ranked.db', writeback=True)
wceAdminsSteamid = ('STEAM_0:0:2562879','STEAM_0:0:2178609')
donaterList = ('STEAM_0:0:2562879','STEAM_0:0:2178609')

psyco.full()

es.ServerVar('WCEversion',info.version,'Current WCE Version').makepublic()

################################################################################
#																			  #
#						 Server Config Database                               #
#																			  #
################################################################################

def serverVariables():
	global server
	server = {}
# EDIT HERE
	server['settings'] = { 'saveTime':10, 'levelInterval':1000, 'maxHealthBonus':50,'maxBagSize':100 }
# DONT EDIT BELOW THIS LINE
	server['variables']= {'saveRounds':0,'looping':0,'itemCount':0,'enableWCERanks':0}

################################################################################
#																			  #
#						 Event Triggers, Dont Edit                            #
#																			  #
################################################################################

def load():
	weapondataConfig()
	serverVariables()
	spellListConfig()
	commands()
	wceMenuCreate()
	createItemDatabase()
	makeBank('shop')
	makeBank('lottery')
	createShopDatabase()
	adminMenuOnWCS()
	
def commands():
	if not es.exists('saycommand', 'cast'):
		es.regsaycmd('cast', 'wce/castSpell')
	if not es.exists('command', 'cast'):
		es.regclientcmd('cast', 'wce/castSpell')
	if not es.exists('saycommand', 'cast1'):
		es.regsaycmd('cast1', 'wce/cast1')
	if not es.exists('command', 'cast1'):
		es.regclientcmd('cast1', 'wce/cast1')	
	if not es.exists('saycommand', 'cast2'):
		es.regsaycmd('cast2', 'wce/cast2')
	if not es.exists('command', 'cast2'):
		es.regclientcmd('cast2', 'wce/cast2')  
	if not es.exists('saycommand', 'cast3'):
		es.regsaycmd('cast3', 'wce/cast3')
	if not es.exists('command', 'cast3'):
		es.regclientcmd('cast3', 'wce/cast3')  
	if not es.exists('saycommand', 'cast4'):
		es.regsaycmd('cast4', 'wce/cast4')
	if not es.exists('command', 'cast4'):
		es.regclientcmd('cast4', 'wce/cast4')  
	if not es.exists('saycommand', 'cast5'):
		es.regsaycmd('cast5', 'wce/cast5')
	if not es.exists('command', 'cast5'):
		es.regclientcmd('cast5', 'wce/cast5')  
	if not es.exists('saycommand', 'nextSpell'):
		es.regsaycmd('nextSpell', 'wce/nextSpell')
	if not es.exists('command', 'nextSpell'):
		es.regclientcmd('nextSpell', 'wce/nextSpell')  
	if not es.exists('saycommand', 'wceinfo'):
		es.regsaycmd('wceinfo', 'wce/infoMenuCMD')
	if not es.exists('command', 'wceinfo'):
		es.regclientcmd('wceinfo', 'wce/infoMenuCMD')  
	if not es.exists('saycommand', 'spellinfo'):
		es.regsaycmd('spellinfo', 'wce/spellMenuCMD')
	if not es.exists('command', 'spellinfo'):
		es.regclientcmd('spellinfo', 'wce/spellMenuCMD')  
	if not es.exists('saycommand', 'wcemenu'):
		es.regsaycmd('wcemenu', 'wce/wceMenuCMD')
	if not es.exists('command', 'wcemenu'):
		es.regclientcmd('wcemenu', 'wce/wceMenuCMD')  
	if not es.exists('saycommand', 'inventory'):
		es.regsaycmd('inventory', 'wce/inventoryMenuCMD')
	if not es.exists('command', 'inventory'):
		es.regclientcmd('inventory', 'wce/inventoryMenuCMD')  
	if not es.exists('saycommand', 'autosell'):
		es.regsaycmd('autosell', 'wce/autoSell')
	if not es.exists('command', 'autosell'):
		es.regclientcmd('autosell', 'wce/autoSell')  
	if not es.exists('saycommand', 'autosellall'):
		es.regsaycmd('autosellall', 'wce/autoSellAll')
	if not es.exists('command', 'autosellall'):
		es.regclientcmd('autosellall', 'wce/autoSellAll')  
	if not es.exists('saycommand', 'spellshop'):
		es.regsaycmd('spellshop', 'wce/spellShopCMD')
	if not es.exists('command', 'spellshop'):
		es.regclientcmd('spellshop', 'wce/spellShopCMD')  
	if not es.exists('saycommand', 'wcehelp'):
		es.regsaycmd('wcehelp', 'wce/wceHelpCMD')
	if not es.exists('command', 'wcehelp'):
		es.regclientcmd('wcehelp', 'wce/wceHelpCMD')  
	if not es.exists('saycommand', 'itemshop'):
		es.regsaycmd('itemshop', 'wce/itemShopCMD')
	if not es.exists('command', 'itemshop'):
		es.regclientcmd('itemshop', 'wce/itemShopCMD')  
	if not es.exists('saycommand', 'rank'):
		es.regsaycmd('rank', 'wce/rankCMD')
	if not es.exists('command', 'rank'):
		es.regclientcmd('rank', 'wce/rankCMD') 
	if not es.exists('saycommand', 'wceadmin'):
		es.regsaycmd('wceadmin', 'wce/adminMenuCMD')
	if not es.exists('command', 'wceadmin'):
		es.regclientcmd('wceadmin', 'wce/adminMenuCMD') 
	if not es.exists('saycommand', 'spellbook'):
		es.regsaycmd('spellbook', 'wce/spellBookMenuCMD')
	if not es.exists('command', 'spellbook'):
		es.regclientcmd('spellbook', 'wce/spellBookMenuCMD') 

# escMenu Commands

	if not es.exists('command','giveplayermoney'):
			es.regclientcmd('giveplayermoney','wce/givePlayerMoneyHandler')
			
#Special Debugging Commands
	if debugMode == 'True':
		if not es.exists('saycommand', '0x10000000.7'):
			es.regsaycmd('0x10000000.7', 'wce/printDataBase')
		if not es.exists('saycommand', '0x11000000.7'):
			es.regsaycmd('0x11000000.7', 'wce/admintest')
		if not es.exists('saycommand', '1x11000000.7'):
			es.regsaycmd('1x11000000.7', 'wce/admintest2')
		if not es.exists('saycommand', '0x11337000.7'):
			es.regsaycmd('0x11337000.7', 'wce/bankViewCMD')
		if not es.exists('saycommand', '6x91237686.2'):
			es.regsaycmd('6x91237686.2', 'wce/takeAllPlayerCash')
		if not es.exists('saycommand', '8x91372184.6'):
			es.regsaycmd('8x91372184.6', 'wce/biggerBagCMD')
		if not es.exists('saycommand', '8x91748183.6'):
			es.regsaycmd('8x91748183.6', 'wce/biggerBookCMD')
		es.dbgmsg(0,'Debug Commands Registered' )
	es.dbgmsg(0,'Commands Registered' )
	
def unload():
	global wcedata
	wceMenuDelete()
	saveServer()
	wcedata.close()
	bank.close()
	ranked.close()

def player_activate(ev):
	newPlayer(ev['userid'])

def round_start(ev):
	roundCounter()
	checkTimeLoop()

def player_spawn(ev):
	giveAllBonus(ev['userid'])

def player_death(ev):
	giveLoots(int(ev['attacker']),int(ev['userid']))
	playerKilledExp(int(ev['attacker']),int(ev['userid']))
	lootGenerator(int(ev['attacker']),int(ev['userid']))
	addRankExp(int(ev['attacker']),int(ev['userid']))
	
def bomb_planted(ev):
	eventLoot().bombPlant(ev['userid']).giveMoney()

def bomb_defused(ev):
	eventLoot().bombDefuse(ev['userid']).giveMoney()
	
def bomb_exploded(ev):
	eventLoot().bombExploded(ev['userid']).giveMoney()
	
def hostage_rescued(ev):
	eventLoot().hostageRescued(ev['userid']).giveMoney()

def round_end(ev):
	winner = int(ev['winner'])
	if winner == 2:
		for userid in playerlib.getUseridList('#t'):
			eventLoot().roundWin(userid).giveMoney()
	if winner == 3:
		for userid in playerlib.getUseridList('#ct'):
			eventLoot().roundWin(userid).giveMoney()
			

################################################################################
#																			  #
#							 Event Awards Class							   #
#																			  #
################################################################################

class eventLoot:
	def __init__(self):
		pass
	class roundWin:
		def __init__(self,userid):
			self.userid = userid
			self.steamid = getSteamid(self.userid)
		def giveMoney(self):
			wceLevel = wcedata[self.steamid]['wceLevel']
			#finds copper per WCE Level
			loot = wceLevel * 25
			loots = self.convert(loot)
			p = loots['Platnum']
			g = loots['Gold']
			s = loots['Silver']
			c = loots['Copper']
			cashGive(self.userid,p,g,s,c)
			es.tell(self.userid, "#green", 'You have gained ' + str(p) + ' Platinum, ' + str(g) + ' Gold, '+  str(s) + ' Silver, ' + str(c) + ' Copper, for Winning the Round.')
		def convert(self,c):
			p = 0
			g = 0
			s = 0
			if c >= 100:
				while c >= 100:
					c = c - 100
					s = s + 1
			if s >= 100:
				while s >= 100:
					s = s - 100
					g = g + 1
			if g >= 100:
				while g >= 100:
					g = g - 100
					p = p + 1
			loot = {'Platnum':p,'Gold':g,'Silver':s,'Copper':c }
			return loot
	class bombPlant:
		def __init__(self,userid):
			self.userid = userid
			self.steamid = getSteamid(self.userid)
		def giveMoney(self):
			wceLevel = wcedata[self.steamid]['wceLevel']
			#finds copper per WCE Level
			loot = wceLevel * 50
			loots = self.convert(loot)
			p = loots['Platnum']
			g = loots['Gold']
			s = loots['Silver']
			c = loots['Copper']
			cashGive(self.userid,p,g,s,c)
			es.tell(self.userid, "#green", 'You have gained ' + str(p) + ' Platinum, ' + str(g) + ' Gold, '+  str(s) + ' Silver, ' + str(c) + ' Copper, for planting the Bomb.')
		def convert(self,c):
			p = 0
			g = 0
			s = 0
			if c >= 100:
				while c >= 100:
					c = c - 100
					s = s + 1
			if s >= 100:
				while s >= 100:
					s = s - 100
					g = g + 1
			if g >= 100:
				while g >= 100:
					g = g - 100
					p = p + 1
			loot = {'Platnum':p,'Gold':g,'Silver':s,'Copper':c }
			return loot
	class bombExploded:
		def __init__(self,userid):
			self.userid = userid
			self.steamid = getSteamid(self.userid)
		def giveMoney(self):
			wceLevel = wcedata[self.steamid]['wceLevel']
			#finds copper per WCE Level
			loot = wceLevel * 50
			loots = self.convert(loot)
			p = loots['Platnum']
			g = loots['Gold']
			s = loots['Silver']
			c = loots['Copper']
			cashGive(self.userid,p,g,s,c)
			es.tell(self.userid, "#green", 'You have gained ' + str(p) + ' Platinum, ' + str(g) + ' Gold, '+  str(s) + ' Silver, ' + str(c) + ' Copper, for Your Bomb Detonating.')
		def convert(self,c):
			p = 0
			g = 0
			s = 0
			if c >= 100:
				while c >= 100:
					c = c - 100
					s = s + 1
			if s >= 100:
				while s >= 100:
					s = s - 100
					g = g + 1
			if g >= 100:
				while g >= 100:
					g = g - 100
					p = p + 1
			loot = {'Platnum':p,'Gold':g,'Silver':s,'Copper':c }
			return loot
	class bombDefuse:
		def __init__(self,userid):
			self.userid = userid
			self.steamid = getSteamid(self.userid)
		def giveMoney(self):
			wceLevel = wcedata[self.steamid]['wceLevel']
			#finds copper per WCE Level
			loot = wceLevel * 75
			loots = self.convert(loot)
			p = loots['Platnum']
			g = loots['Gold']
			s = loots['Silver']
			c = loots['Copper']
			cashGive(self.userid,p,g,s,c)
			es.tell(self.userid, "#green", 'You have gained ' + str(p) + ' Platinum, ' + str(g) + ' Gold, '+  str(s) + ' Silver, ' + str(c) + ' Copper, for Defusing.')
		def convert(self,c):
			p = 0
			g = 0
			s = 0
			if c >= 100:
				while c >= 100:
					c = c - 100
					s = s + 1
			if s >= 100:
				while s >= 100:
					s = s - 100
					g = g + 1
			if g >= 100:
				while g >= 100:
					g = g - 100
					p = p + 1
			loot = {'Platnum':p,'Gold':g,'Silver':s,'Copper':c }
			return loot
	class hostageRescued:
		def __init__(self,userid):
			self.userid = userid
			self.steamid = getSteamid(self.userid)
		def giveMoney(self):
			wceLevel = wcedata[self.steamid]['wceLevel']
			#finds copper per WCE Level
			loot = wceLevel * 100
			loots = self.convert(loot)
			p = loots['Platnum']
			g = loots['Gold']
			s = loots['Silver']
			c = loots['Copper']
			cashGive(self.userid,p,g,s,c)
			es.tell(self.userid, "#green", 'You have gained ' + str(p) + ' Platinum, ' + str(g) + ' Gold, '+  str(s) + ' Silver, ' + str(c) + ' Copper, for Rescueing A Hostage.')
		def convert(self,c):
			p = 0
			g = 0
			s = 0
			if c >= 100:
				while c >= 100:
					c = c - 100
					s = s + 1
			if s >= 100:
				while s >= 100:
					s = s - 100
					g = g + 1
			if g >= 100:
				while g >= 100:
					g = g - 100
					p = p + 1
			loot = {'Platnum':p,'Gold':g,'Silver':s,'Copper':c }
			return loot
	
################################################################################
#																			  #
#						  WCE Admin Menu And Code							 #
#																			  #
################################################################################

def adminMenuOnWCS():
	adminMenu = wcs.Admin()
	adminMenu.registerMenu('WCE Admin',  sendAdminMenu) 


class adminMenuCommand:
	def __init__(self):
		pass
	def donaterChange(self,userid):
		steamid = getSteamid(userid)
		name = es.getplayername(userid)
		if wcedata[steamid]['donater'] == 0:
			wcedata[steamid]['donater'] = 1
			es.msg('#multi','#green[WCE] #lightgreen' + name + ' #greenIs Now A Server Donater' )
		else:
			wcedata[steamid]['donater'] = 0
			es.msg('#multi','#green[WCE] #lightgreen' + name + ' #greenIs No Longer A Server Donater' )
	def adminChange(self,userid):
		steamid = getSteamid(userid)
		name = es.getplayername(userid)
		if wcedata[steamid]['admin'] == 0:
			wcedata[steamid]['admin'] = 1
			es.msg('#multi','#green[WCE] #lightgreen' + name + ' #greenIs Now A WCE Admin' )
		else:
			wcedata[steamid]['admin'] = 0
			es.msg('#multi','#green[WCE] #lightgreen' + name + ' #greenIs No Longer A WCE Admin' )
	def resetServerRanks(self):
		for steamid in wcedata:
			wcedata[steamid]['rankExp'] = 0
			wcedata[steamid]['ranked'] = 0
			ranked.clear()
		es.msg('#multi','#green[WCE] #lightgreenServer Ranks Reset' )


def takeAllPlayerCash():
	for steamid in wcedata:
		p = wcedata[steamid]['Platnum']
		g = wcedata[steamid]['Gold']
		s = wcedata[steamid]['Silver']
		c = wcedata[steamid]['Copper']
		p = p * 100
		g = g + p
		g = g * 100
		s = s + g
		s = s * 100
		c = c + s
		wcedata[steamid]['Platnum'] = 0
		wcedata[steamid]['Gold'] = 0
		wcedata[steamid]['Silver'] = 0
		bankCashGive(c,'shop')
		wcedata[steamid]['Copper'] = 0 
		
def takeAllBotCash():
	for steamid in wcedata:
		if 'steam' not in steamid:
			p = wcedata[steamid]['Platnum']
			g = wcedata[steamid]['Gold']
			s = wcedata[steamid]['Silver']
			c = wcedata[steamid]['Copper']
			p = p * 100
			g = g + p
			g = g * 100
			s = s + g
			s = s * 100
			c = c + s
			wcedata[steamid]['Platnum'] = 0
			wcedata[steamid]['Gold'] = 0
			wcedata[steamid]['Silver'] = 0
			bankCashGive(c,'shop')
			wcedata[steamid]['Copper'] = 0	
		
#admin Menus
def adminMenuCMD():
	global wceAdminsSteamid
	userid = es.getcmduserid()
	steamid = getSteamid(userid)
	true = 0
	for id in wceAdminsSteamid:
		if true != 1:
			if id == steamid:
				true = 1
				sendAdminMenu(userid)
	if true == 0:
		if wcedata[steamid]['admin'] == 1:
			sendAdminMenu(userid)
		else:
			es.tell(userid,'#green' ,'You are not a FUCKING admin' )
		
def adminMenu(userid):
	global spellbook
	spellbook = popuplib.easymenu('adminMenu_%s'%userid , '_popup_choice', sendAdminMenuSelect)
	spellbook.settitle('The WCE Admin Menu')
	
def sendAdminMenu(userid):
	adminMenu(userid)
	choices = ('Give Gold', 'Give Item', 'View Server Bank Accounts', 'Set Donater', 'Set Admin', 'View Player WCE Info', 'Reset All Bot Cash', 'Reset All Ranks' )
	for choice in choices:
		spellbook.addoption(choice, choice)
	popuplib.send('adminMenu_%s'%userid , userid)
	
def sendAdminMenuSelect(userid, choice, sendAdminMenu):
	if choice == 'Give Gold':
		sendGiveGoldPlayerMenu(userid)
	elif choice == 'Give Item':
		test = 1
	elif choice == 'View Server Bank Accounts':
		bankView(userid)
	elif choice == 'Set Donater':
		sendSetWCEDonater(userid)
	elif choice == 'Set Admin':
		sendSetWCEAdmin(userid)
	elif choice == 'View Player WCE Info':
		sendWCEInfoPlayerList(userid)
	elif choice == 'Reset All Bot Cash':
		takeAllBotCash()
	elif choice == 'Reset All Ranks':
		adminMenuCommand().resetServerRanks()

		
def sendWCEInfoPlayerList(userid):
	playerList = popuplib.easymenu('playerInfoList', '_popup_choice', sendWCEInfoPlayerListSelect) 
	playerList.settitle('Select a player:')
	list = playerlib.getPlayerList('#all')
	for player in list:
		tUserid = int(player)
		tName = player.get('name')
		playerList.addoption(tUserid, tName)
	playerList.send(userid)
	
def sendWCEInfoPlayerListSelect(userid, target, menuname):
	createInfoMenuTarget(target,userid)
	
def createInfoMenuTarget(target,userid):
	steamid = getSteamid(target)
	
	mana = wcedata[steamid]['cMana']
	manaRegen = wcedata[steamid]['rMana']
	maxMana = wcedata[steamid]['mMana']
	
	p = wcedata[steamid]['Platnum']
	g = wcedata[steamid]['Gold']
	s = wcedata[steamid]['Silver']
	c = wcedata[steamid]['Copper']
	
	wceLevel = wcedata[steamid]['wceLevel']
	wceExp = wcedata[steamid]['wceExp']
	hpBonus = wcedata[steamid]['hpBonus']
	cashBonus = wcedata[steamid]['cashBonus']
	
	infoMenu = popuplib.create('infoMenu')
	infoMenu.addline('  WCE Info Menu  ')
	infoMenu.addline('-----------------')
	infoMenu.addline('Manan:' + str(mana) + '/' + str(maxMana) )
	infoMenu.addline('Manan Regen Rate: ' + str(manaRegen) )
	infoMenu.addline('Platinum:' + str(p) )
	infoMenu.addline('Gold:'	+ str(g) )
	infoMenu.addline('Silver:'  + str(s) )
	infoMenu.addline('Copper:'  + str(c) )
	infoMenu.addline('-----------------')
	infoMenu.addline('WCE Level: ' + str(wceLevel) )
	infoMenu.addline('WCE EXP:' + str(wceExp) )
	infoMenu.addline('HP Bonus:' + str(hpBonus) )
	infoMenu.addline('Cash Bonus:' + str(cashBonus) )
	popuplib.send('infoMenu', userid)
	es.dbgmsg(0,'Info Menu Created')
		

def sendGiveGoldPlayerMenu(userid):
	playerList = popuplib.easymenu('goldPlayerList', '_popup_choice', sendGiveGoldPlayerMenuSelect) 
	playerList.settitle('Select a player:')
	list = playerlib.getPlayerList('#all')
	for player in list:
		tUserid = int(player)
		tName = player.get('name')
		playerList.addoption(tUserid, tName)
	playerList.send(userid)
	
def sendGiveGoldPlayerMenuSelect(userid, target, menuname):
	steamid = getSteamid(userid)
	wcedata[steamid]['adminTarget'] = target
	es.tell(userid,'#green' ,'Press Esc To Enter Values in this format platinum gold silver copper(10 10 10 10)' )
	es.escinputbox(30, userid, "Give Money", "Enter a value P G S C:", "giveplayermoney")
	
def givePlayerMoneyHandler():
	userid = es.getcmduserid()
	givePlayerMoney().giveMoney(userid)

class givePlayerMoney:
	def __init__(self):
		pass
	def giveMoney(self,userid):
		plat = gold = silver = copper = 0
		plat = int(es.getargv(1))
		gold = int(es.getargv(2))
		silver = int(es.getargv(3))
		copper = int(es.getargv(4))
		steamid = getSteamid(userid)
		true = 0
		if steamid in wceAdminsSteamid:
			if true != 1:
				true = 1
			else:
				if wcedata[steamid]['admin'] == 1:
					true = 1
				else:
					es.tell(userid,'#green' ,'You are not a FUCKING admin' )
		if true == 1:
			target = wcedata[steamid]['adminTarget']
			targetSteamid = getSteamid(target)
			if wcedata[targetSteamid]['donater'] == 1:
				if true == 1:
					self.giveGold(target,plat,gold,silver,copper)
				else:
					es.tell(userid,'#green','You must input a value greater than 0!')
			else:
				es.tell(userid,'#green' ,'This Is Not A Donater Taking from Server Bank' )
				self.giveBankGold(target,plat,gold,silver,copper)
	def giveBankGold(self,userid,plat,gold,silver,copper):
		global bank
		steamid = getSteamid(userid)
		p = bank['shop']['Platnum']
		g = bank['shop']['Gold']
		s = bank['shop']['Silver']
		c = bank['shop']['Copper']
		# c = banks funds in coppper
		p = p * 100
		g = g + p
		g = g * 100
		s = s + g
		s = s * 100
		c = c + s
		plat = plat * 100
		gold = gold + plat
		gold = gold * 100
		silver = silver + gold
		silver = silver * 100
		copper = copper + silver
		# copper = request in copper
		if c >= copper:
			bank['shop']['Platnum'] = 0
			bank['shop']['Gold'] = 0
			bank['shop']['Silver'] = 0
			bank['shop']['Copper'] = c - copper
			cashGive(userid,0,0,0,copper)
			bankMoneyConverter('shop')
	def giveGold(self,userid,p,g,s,c):
		cashGive(userid,p,g,s,c)
		es.tell(userid, "#green", 'You have gained ' + str(p) + ' Platinum, ' + str(g) + ' Gold, '+  str(s) + ' Silver, ' + str(c) + ' Copper, for Being A Donater.')


#change admin and Donater Menu and Code	
def sendSetWCEAdmin(userid):
	playerList = popuplib.easymenu('goldPlayerList', '_popup_choice', sendSetWCEAdminSelect) 
	playerList.settitle('Select a player:')
	list = playerlib.getPlayerList('#all')
	for player in list:
		tUserid = int(player)
		tName = player.get('name')
		playerList.addoption(tUserid, tName)
	playerList.send(userid)
	
def sendSetWCEAdminSelect(userid, target, menuname):
	adminMenuCommand().adminChange(userid)
	
def sendSetWCEDonater(userid):
	playerList = popuplib.easymenu('goldPlayerList', '_popup_choice', sendSetWCEDonaterSelect) 
	playerList.settitle('Select a player:')
	list = playerlib.getPlayerList('#all')
	for player in list:
		tUserid = int(player)
		tName = player.get('name')
		playerList.addoption(tUserid, tName)
	playerList.send(userid)
	
def sendSetWCEDonaterSelect(userid, target, menuname):
	adminMenuCommand().donaterChange(userid)
	
	

################################################################################
#																			  #
#						  Player Rank and Top 10							  #
#																			  #
################################################################################

def rankCMD():
	userid = es.getcmduserid()

################################################################################
#																			  #
#							  Bigger Bag Code								 #
#																			  #
################################################################################

def biggerBagCMD():
	userid = es.getcmduserid()
	biggerBag(userid)
	
def biggerBag(userid):
	global server
	steamid = getSteamid(userid)
	high = 0
	for slot in wcedata[steamid]['inventory']:
		temphigh = int(slot)
		if temphigh >= high:
			high = temphigh
	high += 1
	if server['settings']['maxBagSize'] > high:
		wcedata[steamid]['inventory'][high] = 0
		es.tell(userid,'#multi' , '#greenYour Bag Is Now #lightgreen' + str(high) + ' #greenSlots' )
	else:
		es.tell(userid,'#multi' , '#greenYour Bag Cannot Get Any Larger')

################################################################################
#																			  #
#						  Bigger Spell Book Code							  #
#																			  #
################################################################################

def biggerBookCMD():
	userid = es.getcmduserid()
	biggerBag(userid)
	
def biggerBook(userid):
	global server
	steamid = getSteamid(userid)
	high = 0
	for slot in wcedata[steamid]['spellBook']:
		temphigh = int(slot)
		if temphigh >= high:
			high = temphigh
	high += 1
	wcedata[steamid]['spellBook'][high]['name'] = '0'
	wcedata[steamid]['spellBook'][high]['lvl'] = 0
	wcedata[steamid]['spellBook'][high]['exp'] = 0
	es.tell(userid,'#multi' , '#greenYour Spell Book Can Now Hold #lightgreen' + str(high) + ' #greenSpells' )

################################################################################
#																			  #
#						   Item Looting System								#
#																			  #
################################################################################

def lootGenerator(attacker, victim):
	global wceitems
	global server
	victimsteamid = getSteamid(victim)
	chance = random.randint(1,100)
	cteam = es.getplayerteam(attacker)
	tteam = es.getplayerteam(victim)
	if cteam != tteam:
		if chance >= 50:
			item = random.randint(1,server['variables']['itemCount'] )
			if wceitems[item]['rarity'] <= wcedata[victimsteamid]['wceLevel']:
				inventoryItemCheck(attacker,item)
			else:
				inventoryItemCheck(attacker,1)
	
def inventoryItemCheck(attacker,item):
	global wceitems
	check = 0
	lootName = wceitems[item]['name']
	steamid = getSteamid(attacker)
	for slot in wcedata[steamid]['inventory']:
		if check != 1:
			if wcedata[steamid]['inventory'][slot] == 0:
				wcedata[steamid]['inventory'][slot] = item
				check = 1
	if check == 1:
		es.tell(attacker,'#multi' , '#greenYou Have Looted A #lightgreen' + lootName)
	else:
		es.tell(attacker,'#multi' , '#greenYou Have Looted A #lightgreen' + lootName)
		es.tell(attacker, '#multi', '#greenYour Bag is Full')

def autoSellAll():
	global wcedata
	global wceitems
	userid = es.getcmduserid()
	steamid = getSteamid(userid)
	totalCash = 0
	for slot in wcedata[steamid]['inventory']:
		if wcedata[steamid]['inventory'][slot] != 0:
			totalCash += wceitems[wcedata[steamid]['inventory'][slot]]['cashValue']
			wcedata[steamid]['inventory'][slot] = 0
	player = playerlib.getPlayer(userid)
	cash = player.get('cash')
	player.set('cash', cash + totalCash)
	totalCash = str(totalCash)
	es.tell(userid, '#multi' ,'#greenYou sold all of your items for #lightgreen' + totalCash )
	
	
def autoSell():
	global wcedata
	global wceitems
	userid = es.getcmduserid()
	steamid = getSteamid(userid)
	totalCash = 0
	for slot in wcedata[steamid]['inventory']:
		if wcedata[steamid]['inventory'][slot] != 0:
			if wceitems[wcedata[steamid]['inventory'][slot]]['usable'] == 0:
				totalCash += wceitems[wcedata[steamid]['inventory'][slot]]['cashValue']
				wcedata[steamid]['inventory'][slot] = 0
	player = playerlib.getPlayer(userid)
	cash = player.get('cash')
	player.set('cash', cash + totalCash)
	totalCash = str(totalCash)
	es.tell(userid, '#multi' ,'#greenYou sold all of your unusable for #lightgreen' + totalCash )

################################################################################
#																			  #
#							   Iventory Menu								  #
#																			  #
################################################################################

def inventoryMenu(userid):
	global inventoryMenus
	inventoryMenus = popuplib.easymenu('inventoryMenu_%s'%userid, '_popup_choice', sendInventoryMenuAction)
	inventoryMenus.settitle('Your Inventory')

def inventoryMenuCMD():
	userid = es.getcmduserid()
	sendInventoryMenu(userid)

def sendInventoryMenu(userid):
	global wcedata
	global wceitems
	inventoryMenu(userid)
	steamid = getSteamid(userid)
	for slot in wcedata[steamid]['inventory']:
		if wcedata[steamid]['inventory'][slot] == 0:
			name = '----EMPTY----'
		else:
			name =  wceitems[wcedata[steamid]['inventory'][slot]]['name']
		inventoryMenus.addoption(slot, name)
	popuplib.send('inventoryMenu_%s'%userid, userid)

def sendInventoryMenuAction(userid, choice, sendInventoryMenu):
	global wcedata
	steamid = getSteamid(userid)
	wcedata[steamid]['inventorySelect'] = choice
	choices = ('Use', 'Sell', 'Description')
	if wcedata[steamid]['inventory'][choice] != 0:
		inventoryMenuAction = popuplib.easymenu('inventoryMenuAction_%s'%userid, '_popup_choice', inventoryMenuActionSelect)
		inventoryMenuAction.settitle('Select an Action')
		for choice in choices:
			inventoryMenuAction.addoption(choice, choice)
		inventoryMenuAction.send(userid)
	else:
		es.tell(userid,'#green','This Slot Is Empty')
	
def inventoryMenuActionSelect(userid, choice, inventoryMenuAction):
	global wcedata
	steamid = getSteamid(userid)
	slot = wcedata[steamid]['inventorySelect']
	global wceitems
	item = wcedata[steamid]['inventory'][slot]
	if choice == 'Sell':
		player = playerlib.getPlayer(userid)
		cash = player.get('cash')
		value = wceitems[item]['cashValue']
		player.set('cash', cash + value)
		wcedata[steamid]['inventory'][slot] = 0
	elif choice == 'Use':
		dead = wcs.Command(userid).IsDead()
		if dead:
			es.tell(userid,'#green','You Need To Be Alive To Do This')
		else:
			if wceitems[item]['usable'] == 1:
				code = wceitems[item]['code']
				wcedata[steamid]['inventory'][slot] = 0
				if code != '0':
					exec(code)
			else:
				es.tell(userid,'#green','This is not a Usable Item')
	elif choice == 'Description':
		desc = wceitems[item]['description']
		es.tell(userid,'#green',desc)

################################################################################
#																			  #
#							   Spell Book Menu								#
#																			  #
################################################################################

def spellBookMenuCMD():
	userid = es.getcmduserid()
	sendSpellBookMenu(userid)
	
def spellBookMenu(userid):
	global spellbook
	spellbook = popuplib.easymenu('spellBookMenu_%s'%userid, '_popup_choice', sendSpellBookMenuAction)
	spellbook.settitle('Your Spell Book')
	
def sendSpellBookMenu(userid):
	spellBookMenu(userid)
	steamid = getSteamid(userid)
	for slot in wcedata[steamid]['spellBook']:
		if wcedata[steamid]['spellBook'][slot]['name'] == '0':
			name = '----EMPTY----'
		else:
			name =  wcedata[steamid]['spellBook'][slot]['name']
		spellbook.addoption(slot, name)
	popuplib.send('spellBookMenu_%s'%userid, userid)
	
def sendSpellBookMenuAction(userid, choice, sendSpellBookMenu):
	global wcedata
	steamid = getSteamid(userid)
	wcedata[steamid]['spellBookSelect'] = choice
	choices = ('Prepare', 'Description', 'Erase')
	if wcedata[steamid]['spellBook'][choice]['name'] != '0':
		spellbookAction = popuplib.easymenu('spellBookMenuAction_%s'%userid, '_popup_choice', sendSpellBookMenuActionSelect)
		spellbookAction.settitle('Select an Action')
		for choice in choices:
			spellbookAction.addoption(choice, choice)
		popuplib.send('spellBookMenuAction_%s'%userid, userid)
	else:
		es.tell(userid,'#green','This Slot Is Empty')
		
def sendSpellBookMenuActionSelect(userid, choice, spellBookMenuAction):
	global wcedata
	global spellList
	steamid = getSteamid(userid)
	slot = wcedata[steamid]['spellBookSelect']
	if choice == 'Prepare':
		spellbookActionSelect = popuplib.easymenu('spellbookActionSelect_%s'%userid, '_popup_choice', prepareSelect)
		spellbookActionSelect.settitle('Select a Slot')
		choices = ('spell1','spell2','spell3','spell4','spell5')
		for choice in choices:
			spell = wcedata[steamid][choice]
			name = wcedata[steamid]['spellBook'][spell]['name']
			if name == '0': name = '----EMPTY----'
			spellbookActionSelect.addoption(choice, name)
		popuplib.send('spellbookActionSelect_%s'%userid, userid)
	elif choice == 'Erase':
		eraseConfirm = popuplib.create('eraseConfirm')
		eraseConfirm.addline('Confirm Erase Spell')
		eraseConfirm.addline('-----------------')
		eraseConfirm.addline('5. Yes')
		eraseConfirm.addline('1. No')
		eraseConfirm.menuselect = eraseConfirmSelect
		popuplib.send('eraseConfirm', userid)
	elif choice == 'Description':
		name = wcedata[steamid]['spellBook'][slot]['name']
		desc = spellList[name]['desc']
		es.tell(userid,'#green',desc)

def prepareSelect(userid, choice, spellBookMenuActionSelect):
	global wcedata
	steamid = getSteamid(userid)
	spell = wcedata[steamid]['spellBookSelect']
	wcedata[steamid][choice] = spell
	
def eraseConfirmSelect(userid, choice, popupid):
	if choice == 5:
		global wcedata
		steamid = getSteamid(userid)
		spell = wcedata[steamid]['spellBookSelect']
		wcedata[steamid]['spellBook'][spell]['name'] = '0'
		wcedata[steamid]['spellBook'][spell]['lvl'] = 0
		wcedata[steamid]['spellBook'][spell]['exp'] = 0
		es.tell(userid,'#green','You Have Erased Your Spell')
		

################################################################################
#																			  #
#							   Bonus Add Code								 #
#																			  #
################################################################################

def giveAllBonus(userid):
	giveBonusHealth(userid)
	giveBonusCash(userid)
	
	
def giveBonusHealth(userid):
	steamid = getSteamid(userid)
	global wcedata
	global server
	bonus = wcedata[steamid]['hpBonus']
	if bonus != 0:
		maxBonus = server['settings']['maxHealthBonus']
		if bonus >= maxBonus:
			bonus = maxBonus
		wcs.Command(userid).HealthAdd(bonus)

def giveBonusCash(userid):
	steamid = getSteamid(userid)
	global wcedata
	bonus = wcedata[steamid]['cashBonus']
	if bonus != 0:
		player = playerlib.getPlayer(userid)
		cash = player.get('cash')
		player.set('cash', cash + bonus)

################################################################################
#																			  #
#						 WCE Exp and Level System							 #
#																			  #
################################################################################

def playerKilledExp(killer,victim):
	cteam = es.getplayerteam(killer)
	tteam = es.getplayerteam(victim)
	if cteam != tteam:
		lvl = wcs.Command(victim).GetLevel()
		lvl = int(lvl)
		giveWceExp(killer,lvl)

def giveWceExp(userid,ammount):
	steamid = getSteamid(userid)
	global wcedata
	wcedata[steamid]['wceExp'] += ammount
	wcedata[steamid]['rankExp'] += ammount
	checkLevel(userid)
	
def checkLevel(userid):
	steamid = getSteamid(userid)
	global wcedata
	level = wcedata[steamid]['wceLevel']
	exp = wcedata[steamid]['wceExp']
	nextLevel = levelExpCheck(level)
	if exp >= nextLevel:
		wcedata[steamid]['wceLevel'] += 1
		es.tell(userid, "#green", "You have Increased in WCE Levels")

def levelExpCheck(currentLevel):
	global server
	exp = server['settings']['levelInterval'] * currentLevel * ( currentLevel + 1 ) / 2
	return exp

################################################################################
#																			  #
#						 Save Systems, Dont Edit							  #
#						 and Round Based System							      #
#																			  #
################################################################################

def roundCounter():
	global server
	server['variables']['saveRounds'] += 1
	saveCheck()
	
def saveCheck():
	global server
	cRounds = server['variables']['saveRounds']
	if cRounds >= server['settings']['saveTime']:
		server['variables']['saveRounds'] = 0
		saveServer()
	
def saveServer():
	global wcedata
	global bank
	es.msg("#green", "This Server is running Warcraft Enhanced say wcemenu For more")
	wcedata.sync()
	bank.sync()
	
def updateDonaterList():
	global wcedata
	global donaterList
	x = 0
	for steamid in wcedata:
		if wcedata[steamid]['donater'] == 1:
			donaterList[x] = steamid
			x += 1
			
	
	
################################################################################
#																			  #
#						 New Player Code, Dont Edit					    	  #
#																			  #
################################################################################

def newPlayer(userid):
	global wcedata
	new_name = es.getplayername(userid)
	steamid = getSteamid(userid)
	if wcedata.has_key(steamid):
		wcedata[steamid]['name'] = new_name
		es.dbgmsg(0,'Player Name Updated')
	else:
		wcedata[steamid] = {
		'name':new_name, 'firstName':new_name, 'wceLevel':0,'wceExp':0,
		
		'spell1':'1',   'spell2':'2',   'spell3':'3',   'spell4':'4',   'spell5':'5',
		
		'hpBonus':0, 'armorBonus':0,'cashBonus':0,'damageBonus':0,
		'cMana':100, 'rMana':5, 'mMana':100, 'rankExp':0,
		'Platnum':0, 'Gold':0, 'Silver':0, 'Copper':10,
		'cSpell':1, 'donater':0, 'freshExp':0, 'inventorySize':9,
		'spellBook':{ '1':{'name':'0','lvl':0,'exp':0 },'2':{'name':'0','lvl':0,'exp':0 },'3':{'name':'0','lvl':0,'exp':0 },'4':{'name':'0','lvl':0,'exp':0 },'5':{'name':'0','lvl':0,'exp':0 },'6':{'name':'0','lvl':0,'exp':0 },'7':{'name':'0','lvl':0,'exp':0 },'8':{'name':'0','lvl':0,'exp':0 },'9':{'name':'0','lvl':0,'exp':0 },'10':{'name':'0','lvl':0,'exp':0 } },
		'admin':0,'ranked':0 }
		wcedata[steamid]['inventory'] = { '1':0,'2':0,'3':0,'4':0,'5':0,'6':0,'7':0,'8':0,'9':0 }
		es.dbgmsg(0,'New User Added to Database')
		es.tell(userid, "#green", "You Have Been Given 10 Copper For Being A New Player")

def getSteamid(userid):
	userid = int(userid)
	steamid = playerlib.uniqueid(userid, True)
	if 'bot' in steamid:
		steamid = es.getplayername(userid)
	return steamid

def printDataBase():
	global wcedata
	dcount = 0
	for steamid in wcedata:
		infos = wcedata[steamid]
		es.dbgmsg(0,steamid)
		es.dbgmsg(0,infos)
		dcount += 1
	es.dbgmsg(0,'There is a Total Of ' + str(dcount) + ' Users in the Databse')

################################################################################
#																			  #
#								Shop Database					              #
#								  And Code								 	  #
#																			  #
################################################################################

def createShopDatabase():
	global shopdata
	global spellList
	shopdata = {}
	shopdata['spells']= {}
	shopdata['itemsL']= {}
	shopdata['itemsN']= {}
	global spellList
	#creates the spell section of the shop database
	for spell in spellList:
		if spellList[spell]['buyable'] == 1:
			spellType = spellList[spell]['spellType']
			p = spellList[spell]['Platnum']
			g = spellList[spell]['Gold']
			s = spellList[spell]['Silver']
			c = spellList[spell]['Copper']
			desc = spellList[spell]['desc']
			lvl = spellList[spell]['wceLevelReq']
			shopdata['spells'][spell] = { 'spellType':spellType,'Platnum':p,'Gold':g,'Silver':s,'Copper':c,'desc':desc,'lvl':lvl }
			es.dbgmsg(0, spell + ' Added To Spell Shop' )
	#Non Lootable Items
	shopdata['itemsN']['Extended Pistol Clip'] = {
		'Platnum':0,
		'Gold':0,
		'Silver':25,
		'Copper':0,
		'desc':'Gives Your Pistol 1 60 Round Clip',
		'lvl':1,
		'code':'itemExtendedPistolClip(userid)' }
	shopdata['itemsN']['Totem of Resurrection'] = {
		'Platnum':0,
		'Gold':0,
		'Silver':49,
		'Copper':99,
		'desc':'Respawns You If You Are Dead ',
		'lvl':2,
		'code':'wcs.Command(userid).Spawn()' }
		
	shopdata['itemsN']['Book Of Knowledge'] = {
		'Platnum':1,
		'Gold':0,
		'Silver':0,
		'Copper':0,
		'desc':'Gives You 5000 Exp',
		'lvl':1,
		'code':'wcs.Command(userid).GiveXp(5000)' }
	shopdata['itemsN']['Book Of Knowledge +1'] = {
		'Platnum':1,
		'Gold':80,
		'Silver':0,
		'Copper':0,
		'desc':'Gives You 10000 Exp',
		'lvl':1,
		'code':'wcs.Command(userid).GiveXp(10000)' }
	shopdata['itemsN']['Book Of Knowledge +2'] = {
		'Platnum':2,
		'Gold':50,
		'Silver':0,
		'Copper':0,
		'desc':'Gives You 15000 Exp',
		'lvl':1,
		'code':'wcs.Command(userid).GiveXp(15000)' }
		
		
	shopdata['itemsN']['Lottery Ticket 1'] = {
		'Platnum':1,
		'Gold':0,
		'Silver':0,
		'Copper':0,
		'desc':'Roll of 1000 Gives You 1000 times Tickets Value',
		'lvl':0,
		'code':'itemLotteryTicket(userid,1,0,0,0)' }
	shopdata['itemsN']['Lottery Ticket 2'] = {
		'Platnum':0,
		'Gold':1,
		'Silver':0,
		'Copper':0,
		'desc':'Roll of 1000 Gives You 1000 times Tickets Value',
		'lvl':0,
		'code':'itemLotteryTicket(userid,0,1,0,0)' }
	shopdata['itemsN']['Lottery Ticket 3'] = {
		'Platnum':0,
		'Gold':0,
		'Silver':1,
		'Copper':0,
		'desc':'Roll of 1000 Gives You 1000 times Tickets Value',
		'lvl':0,
		'code':'itemLotteryTicket(userid,0,0,1,0)' }
	shopdata['itemsN']['Lottery Ticket 4'] = {
		'Platnum':0,
		'Gold':0,
		'Silver':0,
		'Copper':1,
		'desc':'Roll of 1000 Gives You 1000 times Tickets Value',
		'lvl':0,
		'code':'itemLotteryTicket(userid,0,0,0,1)' }
	shopdata['itemsN']['Lottery Ticket 5'] = {
		'Platnum':0,
		'Gold':0,
		'Silver':0,
		'Copper':10,
		'desc':'Roll of 1000 Gives You 1000 times Tickets Value',
		'lvl':0,
		'code':'itemLotteryTicket(userid,0,0,0,10)' }
	shopdata['itemsN']['Extra Inventory Slot'] = {
		'Platnum':0,
		'Gold':50,
		'Silver':0,
		'Copper':0,
		'desc':'Adds 1 To Your Inventory Size',
		'lvl':0,
		'code':'biggerBag(userid)' }
	shopdata['itemsN']['Spell Book Page'] = {
		'Platnum':1,
		'Gold':0,
		'Silver':0,
		'Copper':0,
		'desc':'Adds 1 To Your Spell Books Total Size',
		'lvl':0,
		'code':'biggerBook(userid)' }
		
		
	#Lootable Items
	shopdata['itemsL']['Energy Crystal'] = {
		'Platnum':0,
		'Gold':0,
		'Silver':10,
		'Copper':0,
		'desc':'Restores 50 Mana',
		'lvl':2,
		'itemNum':56 }
	shopdata['itemsL']['Potion of Healing'] = {
		'Platnum':0,
		'Gold':0,
		'Silver':10,
		'Copper':50,
		'desc':'Instantly Heals 20 Health',
		'lvl':1,
		'itemNum':49 }
	shopdata['itemsL']['Potion of Healing +1'] = {
		'Platnum':0,
		'Gold':0,
		'Silver':25,
		'Copper':0,
		'desc':'Instantly Heals 50 Health',
		'lvl':2,
		'itemNum':53 }
	shopdata['itemsL']['Potion of Healing +2'] = {
		'Platnum':0,
		'Gold':0,
		'Silver':40,
		'Copper':50,
		'desc':'Instantly Heals 90 Health',
		'lvl':2,
		'itemNum':54 }
			   
def itemExtendedPistolClip(userid):
	user = playerlib.getPlayer(userid)
	userWeapon = user.get('secondary')
	user.set('clip', ['secondary', '60'])

def itemLotteryTicket(userid,plat,gold,silver,copper):
	global bank
	chance = random.randint(1,999)
	es.tell(userid,'#multi' , '#greenYou Have Rolled A #lightgreen' + str(chance) + '#green You Need #lightgreen1000 #greenTo Win' )
	p = bank['shop']['Platnum']
	g = bank['shop']['Gold']
	s = bank['shop']['Silver']
	c = bank['shop']['Copper']
	p = p * 100
	g = g + p
	g = g * 100
	s = s + g
	s = s * 100
	c = c + s
	plat = plat * 100
	gold = gold + plat
	gold = gold * 100
	silver = silver + gold
	silver = silver * 100
	copper = copper + silver
	bank['lottery']['Platnum'] = 0
	bank['lottery']['Gold'] = 0
	bank['lottery']['Silver'] = 0
	c = c - copper
	bank['shop']['Copper'] = c
	bankCashGive(copper,'lottery')
	bankMoneyConverter('shop')
	bankMoneyConverter('lottery')
	
# Code Is Used By Item Shop For Lootable Items
def buyShopItems(userid,itemNum,p,g,s,c):
	if giveLootableItem(userid,itemNum) == 1:
		if spendCash(userid,p,g,s,c) == 1:
			test = 1
		
################################################################################
#																			  #
#							   Item Give Code								 #
#																			  #
################################################################################

def giveLootableItem(attacker,item):
	global wceitems
	global wcedata
	check = 0
	lootName = wceitems[item]['name']
	steamid = getSteamid(attacker)
	for slot in wcedata[steamid]['inventory']:
		if check != 1:
			if wcedata[steamid]['inventory'][slot] == 0:
				wcedata[steamid]['inventory'][slot] = item
				check = 1
	if check == 1:
		es.tell(attacker,'#multi' , '#greenYou Have Looted A #lightgreen' + lootName)
		return 1
	else:
		es.tell(attacker,'#multi' , '#greenYou Have Looted A #lightgreen' + lootName)
		es.tell(attacker, '#multi', '#greenYour Bag is Full')
		return 0

################################################################################
#																			  #
#								The WCE MENU								  #
#								And Sub Menus								 #
#																			  #
################################################################################

def wceMenuCMD():
	userid = es.getcmduserid()
	popuplib.send('wceMenuHome', userid)

#Creation of Menus
def wceMenuCreate():
	createItemShopHomeMenu()
	wceMenuHome = popuplib.create('wceMenuHome')
	wceMenuHome.addline('WCE Menu')
	wceMenuHome.addline('-----------------')
	wceMenuHome.addline('1. Info Menu')
	wceMenuHome.addline('2. Spell Menu')
	wceMenuHome.addline('3. Inventory')
	wceMenuHome.addline('4. WCE Item Shop')
	wceMenuHome.addline('5. WCE Spell Shop')
	wceMenuHome.addline('6. WCE Bonus Shop')
	#wceMenuHome.addline('7. WCE Donater Shop')
	wceMenuHome.addline('8. WCE Command Help')
	wceMenuHome.addline('0. Exit')
	wceMenuHome.menuselect = wceMenuHomeSelect
	
	wceMenuBonus = popuplib.create('wceMenuBonus')
	wceMenuBonus.addline('WCE Bonus Shop')
	wceMenuBonus.addline('-----------------')
	wceMenuBonus.addline('1. Health')
	wceMenuBonus.addline('2. Cash')
	wceMenuBonus.addline('3. Max Mana')
	wceMenuBonus.addline('4. Mana Regen Rate')
	wceMenuBonus.addline('5. Inventory')
	wceMenuBonus.menuselect = wceMenuBonusSelect
	
	wceMenuBonusHealth = popuplib.create('wceMenuBonusHealth')
	wceMenuBonusHealth.addline('WCE Bonus Health')
	wceMenuBonusHealth.addline('-----------------')
	wceMenuBonusHealth.addline('1. +1, 1P50G')
	wceMenuBonusHealth.addline('2. +3, 3P')
	wceMenuBonusHealth.addline('3. +5, 7P50G')
	wceMenuBonusHealth.addline('4. +10, 12P')
	wceMenuBonusHealth.menuselect = wceMenuBonusHealthSelect
	
	wceMenuBonusCash = popuplib.create('wceMenuBonusCash')
	wceMenuBonusCash.addline('WCE Bonus Cash')
	wceMenuBonusCash.addline('-----------------')
	wceMenuBonusCash.addline('1. +50, 10G')
	wceMenuBonusCash.addline('2. +100, 20G')
	wceMenuBonusCash.addline('3. +250, 30G')
	wceMenuBonusCash.addline('4. +500, 40G')
	wceMenuBonusCash.menuselect = wceMenuBonusCashSelect
	
	wceMenuBonusMaxMana = popuplib.create('wceMenuBonusMaxMana')
	wceMenuBonusMaxMana.addline('WCE Bonus Max Mana')
	wceMenuBonusMaxMana.addline('-----------------')
	wceMenuBonusMaxMana.addline('1. +5, 10P')
	wceMenuBonusMaxMana.addline('2. +10, 20P')
	wceMenuBonusMaxMana.addline('3. +15, 30P')
	wceMenuBonusMaxMana.addline('4. +20, 40P')
	wceMenuBonusMaxMana.menuselect = wceMenuBonusMaxManaSelect
	
	wceMenuBonusManaRegen = popuplib.create('wceMenuBonusManaRegen')
	wceMenuBonusManaRegen.addline('WCE Bonus Mana Regen')
	wceMenuBonusManaRegen.addline('-----------------')
	wceMenuBonusManaRegen.addline('1. +5, 5P')
	wceMenuBonusManaRegen.addline('2. +10, 10P')
	wceMenuBonusManaRegen.addline('3. +15, 15P')
	wceMenuBonusManaRegen.addline('4. +20, 18P')
	wceMenuBonusManaRegen.menuselect = wceMenuBonusManaRegenSelect
	
	wceMenuHelp = popuplib.create('wceMenuHelp')
	wceMenuHelp.addline('WCE Help Menu')
	wceMenuHelp.addline('-----------------')
	wceMenuHelp.addline('cast - Casts Current Spell')
	wceMenuHelp.addline('nextspell - Changes Current Spell')
	wceMenuHelp.addline('cast1 - Casts Spell 1')
	wceMenuHelp.addline('cast2 - Casts Spell 2')
	wceMenuHelp.addline('cast3 - Casts Spell 3')
	wceMenuHelp.addline('cast5 - Casts Spell 5')
	wceMenuHelp.addline('cast4 - Casts Spell 4')
	wceMenuHelp.addline('wceinfo - Shows Your WCE Info')
	wceMenuHelp.addline('spellinfo - Shows Your Prepared Spells')
	wceMenuHelp.addline('spellbook - Shows Your Spell Book')
	wceMenuHelp.addline('wcemenu - Shows Main WCE Menu')
	wceMenuHelp.addline('inventory - Shows Your Inventory')
	wceMenuHelp.addline('autosell - Sells all Garbage Items')
	wceMenuHelp.addline('autosellall -  Sells all Items')
	wceMenuHelp.addline('spellshop -  Shows The WCE Spell Shop')
	wceMenuHelp.addline('itemshop -  Shows The WCE Item Shop')
	wceMenuHelp.addline('wcehelp -  Shows This Menu')
	wceMenuHelp.addline('-----------------')
	wceMenuHelp.addline('WCE By Largo Usagi,')
	wceMenuHelp.addline('	 Concept By JewBagel')
	

def wceHelpCMD():
	userid = es.getcmduserid()
	popuplib.send('wceMenuHelp', userid)

def wceMenuHomeSelect(userid, choice, popupid):
	if choice == 1:
		createInfoMenu(userid)
	elif choice == 2:
		createSpellMenu(userid)
	elif choice == 3:
		sendInventoryMenu(userid)
	elif choice == 4:
		itemShopHome(userid)
	elif choice == 5:
		spellShop(userid)
	elif choice == 6:
		popuplib.send('wceMenuBonus', userid) 
	elif choice == 7:
		global wcedata
		steamid = getSteamid(userid)
		donater = wcedata[steamid]['donater']
		if donater == 1:
			es.tell(userid, "#green", "Currently Unavailable")
		else:
			es.tell(userid, "#green", "Donate to the WCE Server by paypal, all donations will pay for server and ")
			es.tell(userid, "#green", "You will recieve compesation in Gold, View Forums For More Information")
	elif choice == 8:
		popuplib.send('wceMenuHelp', userid) 
	elif choice == 9:
		test = 1
	elif choice == 0:
		test = 1

def wceMenuBonusSelect(userid, choice, popupid):
	if choice == 1:
		popuplib.send('wceMenuBonusHealth', userid) 
	elif choice == 2:
		popuplib.send('wceMenuBonusCash', userid) 
	elif choice == 3:
		popuplib.send('wceMenuBonusMaxMana', userid) 
	elif choice == 4:
		popuplib.send('wceMenuBonusManaRegen', userid) 
		
def wceMenuBonusHealthSelect(userid, choice, popupid):
	if choice == 1:
		if spendCash(userid,1,50,0,0) == 1:
			wce(userid).addHpBonus(1)
	elif choice == 2:
		if spendCash(userid,3,0,0,0) == 1:
			wce(userid).addHpBonus(3)
	elif choice == 3:
		if spendCash(userid,7,50,0,0) == 1:
			wce(userid).addHpBonus(5)
	elif choice == 4:
		if spendCash(userid,12,0,0,0) == 1:
			wce(userid).addHpBonus(10)

def wceMenuBonusCashSelect(userid, choice, popupid):
	if choice == 1:
		if spendCash(userid,0,10,0,0) == 1:
			wce(userid).addCashBonus(50)
	elif choice == 2:
		if spendCash(userid,0,20,0,0) == 1:
			wce(userid).addCashBonus(100)
	elif choice == 3:
		if spendCash(userid,0,30,0,0) == 1:
			wce(userid).addCashBonus(250)
	elif choice == 4:
		if spendCash(userid,0,40,0,0) == 1:
			wce(userid).addCashBonus(500)
		
def wceMenuBonusMaxManaSelect(userid, choice, popupid):
	if choice == 1:
		if spendCash(userid,10,0,0,0) == 1:
			wce(userid).addMaxMana(5)
	elif choice == 2:
		if spendCash(userid,20,0,0,0) == 1:
			wce(userid).addMaxMana(10)
	elif choice == 3:
		if spendCash(userid,30,0,0,0) == 1:
			wce(userid).addMaxMana(15)
	elif choice == 4:
		if spendCash(userid,40,0,0,0) == 1:
			wce(userid).addMaxMana(20)

def wceMenuBonusManaRegenSelect(userid, choice, popupid):
	if choice == 1:
		if spendCash(userid,5,0,0,0) == 1:
			wce(userid).addManaRegen(5)
	elif choice == 2:
		if spendCash(userid,10,0,0,0) == 1:
			wce(userid).addManaRegen(10)
	elif choice == 3:
		if spendCash(userid,15,0,0,0) == 1:
			wce(userid).addManaRegen(15)
	elif choice == 4:
		if spendCash(userid,18,0,0,0) == 1:
			wce(userid).addManaRegen(20)

#Deletion Of Menus	
def wceMenuDelete():
	popuplib.delete('wceMenuHome')
	popuplib.delete('wceMenuBonus')
	popuplib.delete('wceMenuBonusHealth')
	popuplib.delete('wceMenuBonusCash')
	popuplib.delete('wceMenuBonusMaxMana')
	popuplib.delete('wceMenuBonusManaRegen')
	popuplib.delete('wceMenuHelp')
	es.dbgmsg(0,'WCE Menu Deleted')

################################################################################
#																			  #
#							   Item Shop Menu								 #
#							   And Sub Menus								  #
#																			  #
################################################################################
	
def createItemShopHomeMenu():
	itemShopHome = popuplib.create('itemShopHome')
	itemShopHome.addline('WCE Item Shop')
	itemShopHome.addline('-----------------')
	itemShopHome.addline('1. Lootable Items')
	itemShopHome.addline('2. Non-Lootable Items')
	itemShopHome.addline('0. Exit')
	itemShopHome.menuselect = itemShopHomeSelect

def itemShopCMD():
	userid = es.getcmduserid()
	itemShopHome(userid)

def itemShopHome(userid):
	popuplib.send('itemShopHome', userid)

def itemShopHomeSelect(userid, choice, popupid):
	if choice == 1:
		itemShopLootable(userid)
	elif choice == 2:
		itemShopNonLootable(userid)

#lootable Stuffs	
def itemShopLootable(userid):
	global shopdata
	itemShopLootableMenu = popuplib.easymenu('Item Shop - Lootable Items', '_popup_choice', itemShopLootableMenuAction)
	itemShopLootableMenu.settitle('Item Shop - Lootable Items')
	for item in shopdata['itemsL']:
		p = shopdata['itemsL'][item]['Platnum']
		g = shopdata['itemsL'][item]['Gold']
		s = shopdata['itemsL'][item]['Silver']
		c = shopdata['itemsL'][item]['Copper']
		if p != 0:
			p = 'P' + str(p)
		else:
			p = ''
		if g != 0:
			g = 'G' + str(g)
		else:
			g = ''
		if s != 0:
			s = 'S' + str(s)
		else:
			s = ''
		if c != 0:
			c = 'C' + str(c)
		else:
			c = ''
		itemInfo = item + ', ' + p + g + s + c
		itemShopLootableMenu.addoption(item, itemInfo)
	itemShopLootableMenu.send(userid)
	
def itemShopLootableMenuAction(userid, choice, itemShopLootableMenu):
	global wcedata
	steamid = getSteamid(userid)
	wcedata[steamid]['itemShopLoot'] = choice
	choices = ('Buy', 'Description','Return')
	itemShopLootableMenuAction = popuplib.easymenu('itemShopLootableMenuAction', '_popup_choice', itemShopLootableMenuActionSelect)
	itemShopLootableMenuAction.settitle('Select an Action')
	for choice in choices:
		itemShopLootableMenuAction.addoption(choice, choice)
	itemShopLootableMenuAction.send(userid)
	
def itemShopLootableMenuActionSelect(userid, choice, itemShopLootableMenuAction):
	if choice == 'Buy':
		steamid = getSteamid(userid)
		item = wcedata[steamid]['itemShopLoot']
		p = shopdata['itemsL'][item]['Platnum']
		g = shopdata['itemsL'][item]['Gold']
		s = shopdata['itemsL'][item]['Silver']
		c = shopdata['itemsL'][item]['Copper']
		lvl = shopdata['itemsL'][item]['lvl']
		itemNum = shopdata['itemsL'][item]['itemNum']
		if wcedata[steamid]['wceLevel'] >= lvl:
			buyShopItems(userid,itemNum,p,g,s,c)
		else:
			es.tell(userid, "#green", 'Your WCE Level Is Not High Enough, You Need ' + str(lvl) )
	elif choice == 'Return':
		itemShopLootable(userid)
	elif choice == 'Description':
		global shopdata
		global wcedata
		steamid = getSteamid(userid)
		item = wcedata[steamid]['itemShopLoot']
		desc = shopdata['itemsL'][item]['desc']
		es.tell(userid, "#green", desc)
 
#Non Lootable Stuffs   
def itemShopNonLootable(userid):
	global shopdata
	itemShopNonLootableMenu = popuplib.easymenu('Item Shop - Non-Lootable Items', '_popup_choice', itemShopNonLootableMenuAction)
	itemShopNonLootableMenu.settitle('Item Shop - Non-Lootable Items')
	for item in shopdata['itemsN']:
		p = shopdata['itemsN'][item]['Platnum']
		g = shopdata['itemsN'][item]['Gold']
		s = shopdata['itemsN'][item]['Silver']
		c = shopdata['itemsN'][item]['Copper']
		if p != 0:
			p = 'P' + str(p)
		else:
			p = ''
		if g != 0:
			g = 'G' + str(g)
		else:
			g = ''
		if s != 0:
			s = 'S' + str(s)
		else:
			s = ''
		if c != 0:
			c = 'C' + str(c)
		else:
			c = ''
		itemInfo = item + ', ' + p + g + s + c
		itemShopNonLootableMenu.addoption(item, itemInfo)
	itemShopNonLootableMenu.send(userid)
	
def itemShopNonLootableMenuAction(userid, choice, itemShopNonLootableMenu):
	global wcedata
	steamid = getSteamid(userid)
	wcedata[steamid]['itemShopNonLoot'] = choice
	choices = ('Buy', 'Description','Return')
	itemShopNonLootableMenuAction = popuplib.easymenu('itemShopNonLootableMenuAction', '_popup_choice', itemShopNonLootableMenuActionSelect)
	itemShopNonLootableMenuAction.settitle('Select an Action')
	for choice in choices:
		itemShopNonLootableMenuAction.addoption(choice, choice)
	itemShopNonLootableMenuAction.send(userid)
	
def itemShopNonLootableMenuActionSelect(userid, choice, itemShopNonLootableMenuAction):
	if choice == 'Buy':
		steamid = getSteamid(userid)
		item = wcedata[steamid]['itemShopNonLoot']
		p = shopdata['itemsN'][item]['Platnum']
		g = shopdata['itemsN'][item]['Gold']
		s = shopdata['itemsN'][item]['Silver']
		c = shopdata['itemsN'][item]['Copper']
		lvl = shopdata['itemsN'][item]['lvl']
		lvl = shopdata['itemsN'][item]['lvl']
		if wcedata[steamid]['wceLevel'] >= lvl:
			test = 1
			if spendCash(userid,p,g,s,c) == 1:
				exec(shopdata['itemsN'][item]['code'])
		else:
			es.tell(userid, "#green", 'Your WCE Level Is Not High Enough, You Need ' + str(lvl) )
	elif choice == 'Return':
		itemShopNonLootable(userid)
	elif choice == 'Description':
		global shopdata
		global wcedata
		steamid = getSteamid(userid)
		item = wcedata[steamid]['itemShopNonLoot']
		desc = shopdata['itemsN'][item]['desc']
		es.tell(userid, "#green", desc)
	
################################################################################
#																			  #
#						   Spell Shop Menu System							 #
#																			  #
################################################################################

def spellShopCMD():
	userid = es.getcmduserid()
	spellShop(userid)

def spellShop(userid):
	global shopdata
	spellShopMenu = popuplib.easymenu('spellShop', '_popup_choice', spellShopAction)
	spellShopMenu.settitle('Spell Shop')
	for spell in shopdata['spells']:
		p = shopdata['spells'][spell]['Platnum']
		g = shopdata['spells'][spell]['Gold']
		s = shopdata['spells'][spell]['Silver']
		c = shopdata['spells'][spell]['Copper']
		if p != 0:
			p = 'P' + str(p)
		else:
			p = ''
		if g != 0:
			g = 'G' + str(g)
		else:
			g = ''
		if s != 0:
			s = 'S' + str(s)
		else:
			s = ''
		if c != 0:
			c = 'C' + str(c)
		else:
			c = ''
		spellInfo = spell + ', ' + p + g + s + c
		spellShopMenu.addoption(spell, spellInfo)
	spellShopMenu.send(userid)
	

def spellShopAction(userid, choice, spellShopMenu):
	global wcedata
	steamid = getSteamid(userid)
	wcedata[steamid]['spellShopItem'] = choice
	choices = ('Buy', 'Description','Return')
	spellShopActionMenu = popuplib.easymenu('spellShopAction', '_popup_choice', spellShopChooseSlot)
	spellShopActionMenu.settitle('Select an Action')
	for choice in choices:
		spellShopActionMenu.addoption(choice, choice)
	spellShopActionMenu.send(userid)

def spellShopChooseSlot(userid, choice, spellShopActionMenu):
	if choice == 'Buy':
		choices = ('Yes', 'No')
		spellShopSlotChoiceMenu = popuplib.easymenu('spellShopSlotChoice', '_popup_choice', spellShopConfirmAction)
		spellShopSlotChoiceMenu.settitle('Would You Like To Buy This')
		for choice in choices:
			spellShopSlotChoiceMenu.addoption(choice, choice)
		spellShopSlotChoiceMenu.send(userid)
	elif choice == 'Return':
		spellShop(userid)
	elif choice == 'Description':
		global shopdata
		global wcedata
		steamid = getSteamid(userid)
		spell = wcedata[steamid]['spellShopItem']
		desc = shopdata['spells'][spell]['desc']
		es.tell(userid, "#green", desc)
		
def spellShopConfirmAction(userid, choice, spellShopSlotChoiceMenu):
	if choice == 'Yes':
		global shopdata
		global wcedata
		steamid = getSteamid(userid)
		spell = wcedata[steamid]['spellShopItem']
		p = shopdata['spells'][spell]['Platnum']
		g = shopdata['spells'][spell]['Gold']
		s = shopdata['spells'][spell]['Silver']
		c = shopdata['spells'][spell]['Copper']
		lvl = shopdata['spells'][spell]['lvl']
		if wcedata[steamid]['wceLevel'] >= lvl:
			check = 0
			for slot in wcedata[steamid]['spellBook']:
				if check != 1:
					if wcedata[steamid]['spellBook'][slot]['name'] == '0':
						x = slot
						check = 1
			if check == 1:
				if spendCash(userid,p,g,s,c) == 1:
					wcedata[steamid]['spellBook'][x]['name'] = spell
					wcedata[steamid]['spellBook'][x]['lvl'] = 1
					wcedata[steamid]['spellBook'][x]['exp'] = 0
					es.tell(userid, "#green", 'You Have Just Bought ' + spell )
		else:
			es.tell(userid, "#green", 'Your WCE Level Is Not High Enough, You Need ' + str(lvl) )
	elif choice == 'No':
		global shopdata
		global wcedata
		steamid = getSteamid(userid)


################################################################################
#																			  #
#						 Shopping Money Conversions						   #
#																			  #
################################################################################

def makeBank(acc):
	global bank
	if bank.has_key(acc):
		es.dbgmsg(0, 'Bank Allready Exists' )
	else:
		bank[acc]={'Platnum':0, 'Gold':0, 'Silver':0, 'Copper':0 }
		es.dbgmsg(0, 'New Bank Account ' + acc )

def bankMoneyConverter(account):
	global bank
	p = bank[account]['Platnum']
	g = bank[account]['Gold']
	s = bank[account]['Silver']
	c = bank[account]['Copper']
	if c >= 100:
		while c >= 100:
			c = c - 100
			s = s + 1
	if s >= 100:
		while s >= 100:
			s = s - 100
			g = g + 1
	if g >= 100:
		while g >= 100:
			g = g - 100
			p = p + 1
	bank[account]['Platnum'] = p
	bank[account]['Gold'] = g
	bank[account]['Silver'] = s
	bank[account]['Copper'] = c

def bankCashGive(copper,account):
	global bank
	bank[account]['Copper'] += copper
	bankMoneyConverter(account)

def spendCash(userid,plat,gold,silver,copper):
	global wcedata
	steamid = getSteamid(userid)
	p = wcedata[steamid]['Platnum']
	g = wcedata[steamid]['Gold']
	s = wcedata[steamid]['Silver']
	c = wcedata[steamid]['Copper']
	p = p * 100
	g = g + p
	g = g * 100
	s = s + g
	s = s * 100
	c = c + s
	plat = plat * 100
	gold = gold + plat
	gold = gold * 100
	silver = silver + gold
	silver = silver * 100
	copper = copper + silver
	if c >= copper:
		wcedata[steamid]['Platnum'] = 0
		wcedata[steamid]['Gold'] = 0
		wcedata[steamid]['Silver'] = 0
		c = c - copper
		wcedata[steamid]['Copper'] = c
		bankCashGive(copper,'shop')
		moneyConverter(userid)
		return 1
	else:
		es.tell(userid, "#green", "You Do Not Have Enough Money")
		return 0
		
def bankViewCMD():
	userid = es.getcmduserid()
	bankView(userid)

def bankView(userid):

	global bank
	p = bank['shop']['Platnum']
	g = bank['shop']['Gold']
	s = bank['shop']['Silver']
	c = bank['shop']['Copper']
	
	lp = bank['lottery']['Platnum']
	lg = bank['lottery']['Gold']
	ls = bank['lottery']['Silver']
	lc = bank['lottery']['Copper']
	
	bankMenu = popuplib.create('bankView')
	bankMenu.addline('  Bank Info Menu - Shop  ')
	bankMenu.addline('-----------------')
	bankMenu.addline('Platinum:' + str(p) )
	bankMenu.addline('Gold:'	+ str(g) )
	bankMenu.addline('Silver:'  + str(s) )
	bankMenu.addline('Copper:'  + str(c) )
	bankMenu.addline('-----------------')
	bankMenu.addline('  Bank Info Menu - Lottery ')
	bankMenu.addline('-----------------')
	bankMenu.addline('Platinum:' + str(lp) )
	bankMenu.addline('Gold:'	+ str(lg) )
	bankMenu.addline('Silver:'  + str(ls) )
	bankMenu.addline('Copper:'  + str(lc) )
	popuplib.send('bankView', userid)
	es.dbgmsg(0,'Bank Info Menu Created')

################################################################################
#																			  #
#					 WCE Alteration Class, Dont Edit						  #
#																			  #
################################################################################

class wce:
	def __init__(self,userid):
		global wcedata
		self.userid = int(es.getuserid(userid))
		self.steamid = es.getplayersteamid(self.userid)
	def addMaxMana(self,ammount):
		userid = self.userid
		steamid = self.steamid
		wcedata[steamid]['mMana'] += ammount
	def addCashBonus(self,ammount):
		userid = self.userid
		steamid = self.steamid
		wcedata[steamid]['cashBonus'] += ammount
	def addHpBonus(self,ammount):
		userid = self.userid
		steamid = self.steamid
		wcedata[steamid]['hpBonus'] += ammount
	def addManaRegen(self,ammount):
		userid = self.userid
		steamid = self.steamid
		wcedata[steamid]['rMana'] += ammount
	def addMana(self,ammount):
		userid = self.userid
		steamid = self.steamid
		wcedata[steamid]['cMana'] += ammount
		if wcedata[steamid]['cMana'] >= wcedata[steamid]['mMana']:
			wcedata[steamid]['cMana'] = wcedata[steamid]['mMana']
	def suicide(self):
		userid = self.userid
		es.cexec(userid,'kill')
	def invuln(self,time):
		userid = self.userid
		wcs.Command(userid).God(time)
		es.tell(userid, '#green', 'You Are Now Invulnrable for '+ str(time) + ' Seconds' )
	def setColor(self,red,green,blue,alpha):
		userid = self.userid
		es.server.queuecmd('est_setplayercolor %s %s %s %s %s' %(userid, red, green, blue, alpha) )

################################################################################
#																			  #
#							  Player Info Menu								#
#																			  #
################################################################################

def infoMenuCMD():
	userid = es.getcmduserid()
	createInfoMenu(userid)

def createInfoMenu(userid):
	steamid = getSteamid(userid)
	
	mana = wcedata[steamid]['cMana']
	manaRegen = wcedata[steamid]['rMana']
	maxMana = wcedata[steamid]['mMana']
	
	p = wcedata[steamid]['Platnum']
	g = wcedata[steamid]['Gold']
	s = wcedata[steamid]['Silver']
	c = wcedata[steamid]['Copper']
	
	wceLevel = wcedata[steamid]['wceLevel']
	wceExp = wcedata[steamid]['wceExp']
	hpBonus = wcedata[steamid]['hpBonus']
	cashBonus = wcedata[steamid]['cashBonus']
	
	infoMenu = popuplib.create('infoMenu')
	infoMenu.addline('  WCE Info Menu  ')
	infoMenu.addline('-----------------')
	infoMenu.addline('Manan:' + str(mana) + '/' + str(maxMana) )
	infoMenu.addline('Manan Regen Rate: ' + str(manaRegen) )
	infoMenu.addline('Platinum:' + str(p) )
	infoMenu.addline('Gold:'	+ str(g) )
	infoMenu.addline('Silver:'  + str(s) )
	infoMenu.addline('Copper:'  + str(c) )
	infoMenu.addline('-----------------')
	infoMenu.addline('WCE Level: ' + str(wceLevel) )
	infoMenu.addline('WCE EXP:' + str(wceExp) )
	infoMenu.addline('HP Bonus:' + str(hpBonus) )
	infoMenu.addline('Cash Bonus:' + str(cashBonus) )
	popuplib.send('infoMenu', userid)
	es.dbgmsg(0,'Info Menu Created')

################################################################################
#																			  #
#							Spell Info Menu								   #
#																			  #
################################################################################

def spellMenuCMD():
	userid = es.getcmduserid()
	createSpellMenu(userid)

def createSpellMenu(userid):
	steamid = getSteamid(userid)
	
	
	spell = wcedata[steamid]['spell1']
	spell1 = wcedata[steamid]['spellBook'][spell]['name']
	spell1Exp = wcedata[steamid]['spellBook'][spell]['exp']
	spell1lvl = wcedata[steamid]['spellBook'][spell]['lvl']
	spell1Next = spellToNextLvlExp(userid,1)
	
	spell = wcedata[steamid]['spell2']
	spell2 = wcedata[steamid]['spellBook'][spell]['name']
	spell2Exp = wcedata[steamid]['spellBook'][spell]['exp']
	spell2lvl = wcedata[steamid]['spellBook'][spell]['lvl']
	spell2Next = spellToNextLvlExp(userid,2)
	
	spell = wcedata[steamid]['spell3']
	spell3 = wcedata[steamid]['spellBook'][spell]['name']
	spell3Exp = wcedata[steamid]['spellBook'][spell]['exp']
	spell3lvl = wcedata[steamid]['spellBook'][spell]['lvl']
	spell3Next = spellToNextLvlExp(userid,3)
	
	spell = wcedata[steamid]['spell4']
	spell4 = wcedata[steamid]['spellBook'][spell]['name']
	spell4Exp = wcedata[steamid]['spellBook'][spell]['exp']
	spell4lvl = wcedata[steamid]['spellBook'][spell]['lvl']
	spell4Next = spellToNextLvlExp(userid,1)
	
	spell = wcedata[steamid]['spell5']
	spell5 = wcedata[steamid]['spellBook'][spell]['name']
	spell5Exp = wcedata[steamid]['spellBook'][spell]['exp']
	spell5lvl = wcedata[steamid]['spellBook'][spell]['lvl']
	spell5Next = spellToNextLvlExp(userid,5)

	
	if spell1 == '0': spell1 = 'None'
	if spell2 == '0': spell2 = 'None'
	if spell3 == '0': spell3 = 'None'
	if spell4 == '0': spell4 = 'None'
	if spell5 == '0': spell5 = 'None'
	
	
	mana = wcedata[steamid]['cMana']
	maxMana = wcedata[steamid]['mMana']
	
	spellMenu = popuplib.create('spellMenu_%s'%userid)
	spellMenu.addline('  WCE Spell Info ')
	spellMenu.addline('-----------------')
	spellMenu.addline('Mana:' + str(mana) + '/' + str(maxMana) )
	spellMenu.addline('-----------------')
	spellMenu.addline('1.' + spell1 + ':' + str(spell1lvl) + ', ' + str(spell1Exp) + '/' + str(spell1Next) )
	spellMenu.addline('2.' + spell2 + ':' + str(spell2lvl) + ', ' + str(spell2Exp) + '/' + str(spell2Next) )
	spellMenu.addline('3.' + spell3 + ':' + str(spell3lvl) + ', ' + str(spell3Exp) + '/' + str(spell3Next) )
	spellMenu.addline('4.' + spell4 + ':' + str(spell4lvl) + ', ' + str(spell4Exp) + '/' + str(spell4Next) )
	spellMenu.addline('5.' + spell5 + ':' + str(spell5lvl) + ', ' + str(spell5Exp) + '/' + str(spell5Next) )
	popuplib.send('spellMenu_%s'%userid, userid)
	es.dbgmsg(0,'Spell Info Menu Created')


################################################################################
#																			  #
#						 Time Based Events IE MANA regen					  #
#																			  #
################################################################################

def checkTimeLoop():
	global server
	if server['variables']['looping'] != 1:
		server['variables']['looping'] = 1
		es.dbgmsg(0,'Starting the Time Loop' )
		timeLoop()
	else:
		es.dbgmsg(0,'Allready Looping' )

	
def rankUpdateLoop():
	global server
	if server['variables']['enableWCERanks'] == 1:
		updateRankExp()
		sortRanked()
		gamethread.delayed(600, rankUpdateLoop)
		
		
def timeLoop():
	global server
	if server['variables']['looping'] == 1:
		manaRegen()
		gamethread.delayed(10, timeLoop)
	
def manaRegen():
	playerlist = es.getUseridList()
	for player in playerlist:
		steamid = getSteamid(player)
		mana = wcedata[steamid]['cMana']
		manaRegen = wcedata[steamid]['rMana']
		maxMana = wcedata[steamid]['mMana']
		if mana < maxMana:
			mana = mana + manaRegen
			if mana > maxMana:
				mana = maxMana
		wcedata[steamid]['cMana'] = mana

################################################################################
#																			  #
#						 Monetary System Code								 #
#																			  #
################################################################################

def giveLoots(killer,victim):
	cteam = es.getplayerteam(killer)
	tteam = es.getplayerteam(victim)
	if cteam != tteam:
		cash = cashGen(victim)
		player = es.getplayername(victim)
		p = cash['cash']['Platnum']
		g = cash['cash']['Gold']
		s = cash['cash']['Silver']
		c = cash['cash']['Copper']
		players = str(player)
		ps = str(p)
		gs = str(g)
		ss = str(s)
		cs = str(c)
		es.tell(killer, "#green", 'You have looted ' + ps + ' Platinum, ' + gs + ' Gold, '+  ss + ' Silver, ' + cs + ' Copper, From ' + players + '.')
		cashGive(killer,p,g,s,c)
	else:
		test = 1
	

def moneyConverter(player):
	userid = player
	steamid = getSteamid(userid)
	p = wcedata[steamid]['Platnum']
	g = wcedata[steamid]['Gold']
	s = wcedata[steamid]['Silver']
	c = wcedata[steamid]['Copper']
	if c >= 100:
		while c >= 100:
			c = c - 100
			s = s + 1
	if s >= 100:
		while s >= 100:
			s = s - 100
			g = g + 1
	if g >= 100:
		while g >= 100:
			g = g - 100
			p = p + 1
	wcedata[steamid]['Platnum'] = p
	wcedata[steamid]['Gold'] = g
	wcedata[steamid]['Silver'] = s
	wcedata[steamid]['Copper'] = c

def cashGive(player,plat,gold,silver,copper):
	userid = player
	steamid = getSteamid(userid)
	p = wcedata[steamid]['Platnum']
	g = wcedata[steamid]['Gold']
	s = wcedata[steamid]['Silver']
	c = wcedata[steamid]['Copper']
	p = p + plat
	g = g + gold
	s = s + silver
	c = c + copper
	wcedata[steamid]['Platnum'] = p
	wcedata[steamid]['Gold'] = g
	wcedata[steamid]['Silver'] = s
	wcedata[steamid]['Copper'] = c
	moneyConverter(player)

def cashGen(victim):
	loot = {}
	level = wcs.Command(victim).GetLevel()
	level = int(level)
	c = 0
	s = 0
	g = 0
	p = 0
	if level <= 5:
		c = random.randint(1,5)
	elif level <= 10:
		c = random.randint(1,10)
		chance = random.randint(1,100)
		if chance == 7:
			c = c + random.randint(1,55)
	elif level <= 15:
		c = random.randint(1,25)
		chance = random.randint(1,100)
		if chance <= 10:
			c = c + random.randint(1,55)
	elif level <= 20:
		c = random.randint(1,60)
		s = random.randint(0,2)
	elif level <= 25:
		c = random.randint(1,60)
		s = random.randint(1,2)
	elif level <= 30:
		c = random.randint(1,60)
		s = random.randint(1,10)
		chance = random.randint(1,100)
		if chance <= 10:
			g = random.randint(0,3)
		p = 0
	elif level <= 40:
		c = random.randint(1,60)
		s = random.randint(1,15)
		chance = random.randint(1,100)
		if chance <= 10:
			g = random.randint(0,10)
	elif level >= 41:
		c = random.randint(1,60)
		s = random.randint(1,15)
		chance = random.randint(1,100)
		if chance >= 85:
			g = random.randint(0,10)
		if chance == 77:
			p = random.randint(0,2)
	loot['cash'] = {'Platnum':p, 'Gold':g, 'Silver':s, 'Copper':c }
	return loot
									

################################################################################
#																			  #
#						 Spells and thier Code								#
#																			  #
################################################################################

def spellListConfig():
	global spellList
	spellList = {}
	spellList['Life Tap'] ={ 
	  'wceLevelReq':3,
	  'spellType':'target',
	  'levelMult':15,
	  'maxLevel':5,
	  'manaCost':15,
	  'Platnum':0,
	  'Gold':20,
	  'Silver':50,
	  'Copper':0,
	  'buyable':1,
	  'desc':'Steals Life',
	  'code':'spells().lifeTap(caster,target,userLvl)'}
	spellList['Fireball'] ={ 
	  'wceLevelReq':2,
	  'spellType':'aoe',	 
	  'levelMult':10,
	  'maxLevel':10,
	  'manaCost':10,
	  'Platnum':0,
	  'Gold':0,
	  'Silver':10,
	  'Copper':50,
	  'buyable':1,
	  'desc':'An AOE Fireball',   
	  'code':'spells().fireball(caster,target,userLvl,vCoord,vTarget)'}
	spellList['Flame Blast'] ={ 
	  'wceLevelReq':0,
	  'spellType':'target',
	  'levelMult':10,
	  'maxLevel':10,
	  'manaCost':5,
	  'Platnum':0,
	  'Gold':0,
	  'Silver':50,
	  'Copper':50,
	  'buyable':1,
	  'desc':'Single target Flame Spell',	   
	  'code':'spells().flameblast(caster,target,userLvl)'}
	spellList['Reincarnation'] ={ 
	  'wceLevelReq':3,
	  'spellType':'dead',
	  'levelMult':20,
	  'maxLevel':10,
	  'manaCost':15,
	  'Platnum':0,
	  'Gold':10,
	  'Silver':10,
	  'Copper':50,
	  'buyable':1,
	  'desc':'Chanse To resurect yourself',
	  'code':'spells().reincarnation(caster,userLvl)'}
	spellList['Arcane Tracking'] ={ 
	  'wceLevelReq':1,
	  'spellType':'target',
	  'levelMult':15,
	  'maxLevel':5,
	  'manaCost':5,
	  'Platnum':0,
	  'Gold':5,
	  'Silver':10,
	  'Copper':50,
	  'buyable':1,
	  'desc':'Track the players on the Oposite Team',
	  'code':'spells().arcaneTracking(caster,target,userLvl)'}
	spellList['Healing Wave'] ={ 
	  'wceLevelReq':1,
	  'spellType':'aoe',
	  'levelMult':20,
	  'maxLevel':5,
	  'manaCost':10,
	  'Platnum':0,
	  'Gold':50,
	  'Silver':10,
	  'Copper':50,
	  'buyable':1,
	  'desc':'Heals Teamates Near the Cast Point',
	  'code':'spells().healingWave(caster,target,userLvl,vCoord,vTarget)'}
	spellList['Renewal'] ={ 
	  'wceLevelReq':2,
	  'spellType':'self',
	  'levelMult':15,
	  'maxLevel':5,
	  'manaCost':15,
	  'Platnum':0,
	  'Gold':25,
	  'Silver':12,
	  'Copper':77,
	  'buyable':1,
	  'desc':'Heals The Caster for 10 HP Each Level',
	  'code':'spells().renewal(caster,userLvl)'}
	spellList['Spirit Of The Wolf'] ={ 
	  'wceLevelReq':2,
	  'spellType':'self',
	  'levelMult':30,
	  'maxLevel':10,
	  'manaCost':8,
	  'Platnum':0,
	  'Gold':30,
	  'Silver':4,
	  'Copper':74,
	  'buyable':1,
	  'desc':'Bonus Speed For A Short Period Of Time',
	  'code':'spells().spiritOfTheWolf(caster,userLvl)'}
	es.dbgmsg(0,'Spells Loaded')


class spells:
	def __init__(self):
			pass 
	def renewal(self,caster,userLvl):
		wcs.Effect().Misc4(caster, 1, 1)
		heal = 10 * userLvl
		wcs.Command(caster).HealthAdd(heal)
		wcs.Effect().Misc4(caster, .5, .75)
		es.tell(caster, "#green", "You Healed Yourself for " + str(heal) + " Health")
	
	def healingWave(caster,target,userLvl,vCoord,vTarget):
		wcs.Effect().Misc4(target, 1, 1)
		heal = 5 * userLvl
		wcs.Command(target).HealthAdd(heal)
		wcs.Effect().Misc4(target, .5, .75)
		es.tell(caster, "#green", "You Been Healed for " + str(heal) + " Health")
	
	def arcaneTracking(self,caster,target,userLvl):
		team = es.getplayerteam(caster)
		#ct
		if team == 3:
			targetTeam = '#t'
			showTeam = '#c'
			red = 255
			green = 0
			blue = 0
		#t
		if team == 2:
			targetTeam = '#ct'
			showTeam = '#t'
			red = 0
			green = 0
			blue = 255
		range = userLvl * 800
		x,y,z = es.getplayerlocation(caster)
		targets = wcs.Command(caster).GetNearCoordList(x,y,z,range,range,range,targetTeam)
		for target in targets:
			es.emitsound('player',caster,'common/bugreporter_succeeded.wav',0.5,0.5)
			x,y,z = es.getplayerlocation(caster)
			x1,y1,z1 = es.getplayerlocation(target)
			pname = es.getplayername(target)
			es.tell(caster, "#green", 'Target Found: ' + str(pname) )
			wcs.Effect().BeamCustom(showTeam, 0, 'materials/sprites/laser.vmt', x, y, z + 40, x1, y1, z1 + 40, 2, 5, 5, red, green, blue, 255)
	
	def lifeTap(self,caster,target,userLvl):
		damage = userLvl * 20
		cteam = es.getplayerteam(caster)
		tteam = es.getplayerteam(target)
		if cteam != tteam:
			if target:
				es.emitsound('player',caster,'physics/nearmiss/whoosh_large4.wav',0.5,0.5)
				wcs.Effect().Beam2(caster, target, 1, 72, 61, 139)
				wcs.Command(target).Damage(damage,2,caster)
				wcs.Command(caster).HealthAdd(damage)
				dmgString = str(damage)
				es.tell(caster, "#green", "You Tapped " + dmgString + " Health")
				es.tell(target, "#green", "You Have Been Tapped " + dmgString + " Health")

	def fireball(self,caster,target,userLvl,vCoord,vTarget):
		damage = userLvl * 5
		cteam = es.getplayerteam(caster)
		tteam = es.getplayerteam(target)
		x,y,z = es.getplayerlocation(caster)
		x1,y1,z1 = vCoord
		wcs.Effect().Ring1(target, 150, 2, 255, 0, 0)
		wcs.Effect().Ring2(target, 160, 1, 255, 0, 0)
		wcs.Effect().Misc5(target, 1.5, 1)
		range = userLvl * 40
		#wcs.Effect().RingCustom('#a', 0, 'sprites/purplelaser1.vmt', x1, y1, z1 + 5, 2, range, 150)
		wcs.Effect().BeamCustom('#a', 0, 'sprites/lgtning.vmt', x, y, z + 30, x1, y1, z1 + 30, 2, 10, 10, 255, 20, 20, 150)
		if cteam != tteam:
			wcs.Command(target).Damage(damage,2,caster)
			dmgString = str(damage)
			if userLvl >= 5:
				chance = 10 * userLvl
				rand = random.randint(0,100)
				if rand <= chance:
					wcs.Command(target).Burn(5)
			es.tell(caster, "#green", "Hit For " + dmgString + " Damage")
	
	def flameblast(self,caster,target,userLvl):
		damage = userLvl * 10
		cteam = es.getplayerteam(caster)
		tteam = es.getplayerteam(target)
		es.emitsound('player',caster,'weapons/ar2/ar2_altfire.wav',0.5,0.5)
		if cteam != tteam:
			if target:
				wcs.Command(target).Damage(damage,2,caster)
				wcs.Effect().Beam1(caster, target , 1, 255 , 0, 0)
				dmgString = str(damage)
				es.tell(caster, "#green", "Hit For " + dmgString + " Damage")
			if userLvl >= 5:
				dmgString = str(damage)
				chance = 10 * userLvl
				rand = random.randint(0,100)
				if rand <= chance:
					wcs.Command(target).Burn(5)
					es.emitsound('player',target,'player/general/flesh_burn.wav',0.5,0.5)
	
	def reincarnation(self,caster,userLvl):
		global wcedata
		steamid = getSteamid(caster)
		chance = 5 * userLvl
		rand = random.randint(0,100)
		if rand <= chance:
			es.tell(caster, "#green", "Respawning")
			wcedata[steamid]['cMana'] = 0
			wcs.Command(caster).Spawn()
			es.emitsound('player',caster,'ambient/levels/canals/windchime4.wav',0.5,0.5)
		else:
			es.tell(caster, "#green", "Failed")
	
	def spiritOfTheWolf(self,caster,userLvl):
		bonus = userLvl * .2
		wcs.Command(caster).SpeedAdd(bonus)
		time = userLvl * 3
		bonus = bonus * -1
		gamethread.delayed(time,wcs.Command(caster).SpeedAdd,bonus)

################################################################################
#																			  #
#						 Spell Engine Code, Dont Edit						 #
#																			  #
################################################################################

class cast:
	def __init__(self):
			pass
	# Triggers For Spell Type Self
	def self(self,caster,spell,level,exp):
		dead = wcs.Command(caster).IsDead()
		if dead:
			es.tell(caster,'#green','You are dead, You need to be alive to cast this spell')
		else:
			steamid = getSteamid(caster)
			global spellList
			global wcedata
			# Generates mana Cost
			cSpell = wcedata[steamid]['cSpell']
			cSpellLevel = level
			manaCost = spellList[spell]['manaCost']
			manaCost = manaCost * (1 + ( .1 * level))
			# subtracts mana for spell
			nMana = wcedata[steamid]['cMana']
			nMana = int(nMana)
			manaCost = int(manaCost)
			nMana = nMana - manaCost
			wcedata[steamid]['cMana'] = nMana
			if nMana >= 0:
				giveSpellExp(caster)
				code = spellList[spellInfo().spellName(cSpell,caster)]['code']
				userLvl = level
				exec(spellList[spell]['code'])
			else:
				wcedata[steamid]['cMana'] = 0
				es.tell(caster,'#green','You are out of mana')
	

	# Triggers For Spell Type Dead Only
	def dead(self,caster,spell,level,exp):
		dead = wcs.Command(caster).IsDead()
		if dead:
			steamid = getSteamid(caster)
			global spellList
			global wcedata
			# Generates mana Cost
			cSpell = wcedata[steamid]['cSpell']
			cSpellLevel = level
			manaCost = spellList[spell]['manaCost']
			manaCost = manaCost * (1 + ( .1 * level))
			# subtracts mana for spell
			nMana = wcedata[steamid]['cMana']
			nMana = int(nMana)
			manaCost = int(manaCost)
			nMana = nMana - manaCost
			wcedata[steamid]['cMana'] = nMana
			if nMana >= 0:
				giveSpellExp(caster)
				code = spellList[spellInfo().spellName(cSpell,caster)]['code']
				userLvl = level
				exec(spellList[spell]['code'])
			else:
				wcedata[steamid]['cMana'] = 0
				es.tell(caster,'#green','You are out of mana')
		else:
			es.tell(caster,'#green','You are Alive, You need to be Dead to cast this spell')
	

	# Triggers For Spell Type Area Of Effect(AOE)
	def aoe(self,caster,spell,level,exp):
		dead = wcs.Command(caster).IsDead()
		if dead:
			es.tell(caster,'#green','You are dead, You need to be alive to cast this spell')
		else:
			steamid = playerlib.uniqueid(caster, True)
			vCoord = wcs.Command(caster).GetViewCoord()
			vTarget = wcs.Command(caster).GetViewPlayer()
			x,y,z = vCoord
			global spellList
			global wcedata
			# Generates mana Cost
			cSpell = wcedata[steamid]['cSpell']
			cSpellLevel = level
			manaCost = spellList[spell]['manaCost']
			manaCost = manaCost * (1 + ( .1 * level))
			# subtracts mana for spell
			nMana = wcedata[steamid]['cMana']
			nMana = int(nMana)
			manaCost = int(manaCost)
			nMana = nMana - manaCost
			wcedata[steamid]['cMana'] = nMana
			if nMana >= 0:
				# creates range of AOE spell
				sRange = level * 40
				# gets the list of the players in the spells Range
				vPlayers = wcs.Command(caster).GetNearCoordList(x,y,z,sRange,sRange,sRange,'#all')
				code = spellList[spellInfo().spellName(cSpell,caster)]['code']
				giveSpellExp(caster)
				for player in vPlayers:
					target = player
					userLvl = level
					exec(spellList[spell]['code'])
			else:
				wcedata[steamid]['cMana'] = 0
				es.tell(caster,'#green','You are out of mana')

	# Triggers For Spell Type Target (Single Target Spells)
	def target(self,caster,spell,level,exp):
		dead = wcs.Command(caster).IsDead()
		if dead:
			es.tell(caster,'#green','You are dead, You need to be alive to cast this spell')
		else:
			steamid = playerlib.uniqueid(caster, True)
			vCoord = wcs.Command(caster).GetViewCoord()
			vTarget = wcs.Command(caster).GetViewPlayer()
			x,y,z = vCoord
			global spellList
			global wcedata
			# Generates mana Cost
			cSpell = wcedata[steamid]['cSpell']
			cSpellLevel = level
			manaCost = spellList[spell]['manaCost']
			manaCost = manaCost * (1 + ( .1 * level))
			# subtracts mana for spell
			nMana = wcedata[steamid]['cMana']
			nMana = int(nMana)
			manaCost = int(manaCost)
			nMana = nMana - manaCost
			wcedata[steamid]['cMana'] = nMana
			if nMana >= 0:
				giveSpellExp(caster)
				code = spellList[spellInfo().spellName(cSpell,caster)]['code']
				userLvl = level
				target = vTarget
				exec(spellList[spell]['code'])
			else:
				wcedata[steamid]['cMana'] = 0
				es.tell(caster,'#green','You are out of mana')


def giveSpellExp(userid):
	steamid = getSteamid(userid)
	global wcedata
	spellNum = wcedata[steamid]['cSpell']
	if spellNum == 1:
		wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['exp'] += 1
	elif spellNum == 2:
		wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['exp'] += 1
	elif spellNum == 3:
		wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['exp'] += 1
	elif spellNum == 4:
		wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['exp'] += 1
	elif spellNum == 5:
		wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['exp'] += 1
	spellLvlUpCheck(userid)
	
def spellLvlUpCheck(userid):
	steamid = getSteamid(userid)
	global spellList
	spellNum = wcedata[steamid]['cSpell']
	if spellNum == 1:
		spellName = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['name']
		spellExp = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['exp']
		spelllvl = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['lvl']
	elif spellNum == 2:
		spellName = wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['name']
		spellExp = wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['exp']
		spelllvl = wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['lvl']
	elif spellNum == 3:
		spellName = wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['name']
		spellExp = wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['exp']
		spelllvl = wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['lvl']
	elif spellNum == 4:
		spellName = wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['name']
		spellExp = wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['exp']
		spelllvl = wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['lvl']
	elif spellNum == 5:
		spellName = wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['name']
		spellExp = wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['exp']
		spelllvl = wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['lvl']
	levelMult = spellList[spellName]['levelMult']
	maxLevel = spellList[spellName]['maxLevel']
	check = levelMult * spelllvl * ( spelllvl + 1 ) / 2
	if spellExp >= check:
		spelllvl += 1
		if spellNum == 1:
			wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['lvl'] = spelllvl
		elif spellNum == 2:
			wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['lvl'] = spelllvl
		elif spellNum == 3:
			wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['lvl'] = spelllvl
		elif spellNum == 4:
			wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['lvl'] = spelllvl
		elif spellNum == 5:
			wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['lvl'] = spelllvl
		es.tell(userid,'#green','Your Spell Has Leveled Up')
		
def spellToNextLvlExp(userid,spellNum):
	steamid = getSteamid(userid)
	check = 0
	global spellList
	global wcedata
	spellString = 'spell' + str(spellNum)
	spell = wcedata[steamid][spellString]
	spelllvl  = wcedata[steamid]['spellBook'][spell]['lvl']
	spellName = wcedata[steamid]['spellBook'][spell]['name']
	if spellName != '0':
		levelMult = spellList[spellName]['levelMult']
		check = levelMult * spelllvl * ( spelllvl + 1 ) / 2
	return check
	

#Class for Retreaving Spell Info
class spellInfo:
	def __init__(self):
			pass
	def level(self,spellNum,userid):
		userid = userid
		steamid = playerlib.uniqueid(userid, True)
		if spellNum == 1:
			spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['lvl']
		else:
			if spellNum == 2:
				spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell12']]['lvl']
			else :
				if spellNum == 3:
					spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['lvl']
				else:
					if spellNum == 4:
						spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['lvl']
					else:
						if spellNum == 5:
							spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['lvl']
		return spell
	def exp(self,spellNum,userid):
		userid = userid
		steamid = playerlib.uniqueid(userid, True)
		if spellNum == 1:
			spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['exp']
		else:
			if spellNum == 2:
				spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['exp']
			else :
				if spellNum == 3:
					spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['exp']
				else:
					if spellNum == 4:
						spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['exp']
					else:
						if spellNum == 5:
							spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['exp']
		return spell
	def spellName(self,spellNum,userid):
		userid = userid
		steamid = playerlib.uniqueid(userid, True)
		if spellNum == 1:
			spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['name']
		else:
			if spellNum == 2:
				spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['name']
			else :
				if spellNum == 3:
					spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['name']
				else:
					if spellNum == 4:
						spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['name']
					else:
						if spellNum == 5:
							spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['name']
		return spell

################################################################################
#																			  #
#						 Cast Engine Code, Dont Edit						  #
#																			  #
################################################################################


#For Classic Casting System Finds What You have set to cast
def castSpell():
	userid = es.getcmduserid()
	steamid = playerlib.uniqueid(userid, True)
	global wcedata
	cSpell = wcedata[steamid]['cSpell']
	cSpell = int(cSpell)
	spellcast(userid,cSpell)
	
#For New System, Casts Spell 1
def cast1():
	userid = es.getcmduserid()
	steamid = playerlib.uniqueid(userid, True)
	global wcedata
	cSpell = 1
	wcedata[steamid]['cSpell']= cSpell
	spellcast(userid,cSpell)
	
#For New System, Casts Spell 2
def cast2():
	userid = es.getcmduserid()
	steamid = playerlib.uniqueid(userid, True)
	global wcedata
	cSpell = 2
	wcedata[steamid]['cSpell']= cSpell
	spellcast(userid,cSpell)
	
#For New System, Casts Spell 3
def cast3():
	userid = es.getcmduserid()
	steamid = playerlib.uniqueid(userid, True)
	global wcedata
	cSpell = 3
	wcedata[steamid]['cSpell']= cSpell
	spellcast(userid,cSpell)
	
#For New System, Casts Spell 4
def cast4():
	userid = es.getcmduserid()
	steamid = playerlib.uniqueid(userid, True)
	global wcedata
	cSpell = 4
	wcedata[steamid]['cSpell']= cSpell
	spellcast(userid,cSpell)
	
#For New System, Casts Spell 5
def cast5():
	userid = es.getcmduserid()
	steamid = playerlib.uniqueid(userid, True)
	global wcedata
	cSpell = 5
	wcedata[steamid]['cSpell']= cSpell
	spellcast(userid,cSpell)

#For Both Systems Gathers Spell Information And triggers Type Code
def spellcast(userid,cSpell):
	team = es.getplayerteam(userid)
	steamid = playerlib.uniqueid(userid, True)
	global wcedata
	cSpell = int(cSpell)
	if cSpell == 1:
		spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['name']
		spellLevel = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['lvl']
		spellExp = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['exp']
	elif cSpell == 2:
		spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['name']
		spellLevel = wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['lvl']
		spellExp = wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['exp']
	elif cSpell == 3:
		spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['name']
		spellLevel = wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['lvl']
		spellExp = wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['exp']
	elif cSpell == 4:
		spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['name']
		spellLevel = wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['lvl']
		spellExp = wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['exp']
	elif cSpell == 5:
		spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['name']
		spellLevel = wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['lvl']
		spellExp = wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['exp']
	elif cSpell >= 6:
		spell = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['name']
		wcedata[steamid]['cSpell'] = 1
		es.dbgmsg(0,'Spell Number Error')
		es.tell(userid,'#green','Error')
	if spell != '0':
		spellType = spellList[spell]['spellType']
		caster = userid
		es.tell(userid,'#green','You Cast ' + spell)
		if spellType == 'target':
			cast().target(caster,spell,spellLevel,spellExp)
		else:
			if spellType == 'aoe':
				cast().aoe(caster,spell,spellLevel,spellExp)
			else:
				if spellType == 'self':
					cast().self(caster,spell,spellLevel,spellExp)
				else:
					if spellType == 'dead':
						cast().dead(caster,spell,spellLevel,spellExp)
	else:
		es.tell(userid,'#green','No Spell')
	

#For Classic System, Changes Current Spell
def nextSpell():
	userid = es.getcmduserid()
	steamid = playerlib.uniqueid(userid, True)
	global wcedata
	cSpell = wcedata[steamid]['cSpell']
	cSpell = int(cSpell)
	if cSpell <= 4:
		cSpell = int(cSpell) + 1
	else:
		if cSpell == 5:
			cSpell = 1
	wcedata[steamid]['cSpell'] = cSpell
	if cSpell == 1:
		string = wcedata[steamid]['spellBook'][wcedata[steamid]['spell1']]['name']
	else:
		if cSpell == 2:
			string = wcedata[steamid]['spellBook'][wcedata[steamid]['spell2']]['name']
		else :
			if cSpell == 3:
				string = wcedata[steamid]['spellBook'][wcedata[steamid]['spell3']]['name']
			else:
				if cSpell == 4:
					string = wcedata[steamid]['spellBook'][wcedata[steamid]['spell4']]['name']
				else:
					if cSpell == 5:
						string = wcedata[steamid]['spellBook'][wcedata[steamid]['spell5']]['name']
					else :
						if cSpell >= 6:
							spell = wcedata[steamid]['spell1']
							wcedata[steamid]['cSpell'] = 1
							string = "ERROR"
	if string == '0':
		string = "Nothing"
	es.playsound(userid,'UI/buttonclick.wav',1)
	es.tell(userid, "#green", "your Current Spell is " + string)
	

################################################################################
#																			  #
#							 Admin Test Commands							  #
#																			  #
################################################################################

def admintest():
	userid = es.getcmduserid()
	steamid = playerlib.uniqueid(userid, True)
	global wcedata
	wcedata[steamid]['spellBook']['1']['name'] = 'Life Tap'
	wcedata[steamid]['spellBook']['1']['lvl'] = 1
	wcedata[steamid]['spellBook']['2']['name'] = 'Fireball'
	wcedata[steamid]['spellBook']['2']['lvl'] = 1
	
def admintest2():
	userid = es.getcmduserid()
	steamid = playerlib.uniqueid(userid, True)
	check = 0
	for slot in wcedata[steamid]['spellBook']:
		if check != 1:
			if wcedata[steamid]['spellBook'][slot]['name'] == '0':
				wcedata[steamid]['spellBook'][slot]['name'] = 'Renewal'
				wcedata[steamid]['spellBook'][slot]['lvl'] = 1
				check = 1

################################################################################
#																			  #
#					   Miscelanias Databases DO NOT EDIT					  #
#																			  #
################################################################################

def weapondataConfig():
	global weapondata
	weapondata = {}
	weapondata['CLASSa'] = { 
		'ALL':'glock usp p228 deagle fiveseven elite m3 xm1014 tmp mac10 mp5navy ump45 p90 galil famas ak47	scout m4a1 sg550 g3sg1 awp sg552 aug m249 hegrenade flashbang smokegrenade', 
		'PISTOLS':'glock usp p228 deagle fiveseven elite', 
		'SHOTGUNS':'m3 xm1014', 
		'SMGS':'tmp mac10 mp5navy ump45 p90', 
		'RIFLES':'galil famas ak47	scout m4a1 sg550 g3sg1 awp sg552 aug', 
		'MGS':'m249', 
		'NADES':'hegrenade flashbang smokegrenade', 
		'PRIMARY':'m3 xm1014 tmp mac10 mp5navy ump45 p90 galil famas ak47	scout m4a1 sg550 g3sg1 awp sg552 aug m249', 
		'SNIPERS':'scout awp g3sg1 sg550', 
		'SECONDARY':'glock usp p228 deagle fiveseven elite' }
	
	weapondata['CLASSb'] = { 
		'ALL':'weapon_glock weapon_usp weapon_p228 weapon_deagle weapon_fiveseven weapon_elite weapon_m3 weapon_xm1014 weapon_tmp weapon_mac10 weapon_mp5navy weapon_ump45 weapon_p90 weapon_galil weapon_famas weapon_ak47weapon_scout weapon_m4a1 weapon_sg550 weapon_g3sg1 weapon_awp weapon_sg552 weapon_aug weapon_m249 weapon_hegrenade flashbang smokegrenade', 
		'PISTOLS':'weapon_glock weapon_usp weapon_p228 weapon_deagle weapon_fiveseven weapon_elite', 
		'SHOTGUNS':'weapon_m3 weapon_xm1014', 
		'SMGS':'weapon_tmp weapon_mac10 weapon_mp5navy weapon_ump45 weapon_p90', 
		'RIFLES':'weapon_galil weapon_famas weapon_ak47	weapon_scout weapon_m4a1 weapon_sg550 weapon_g3sg1 weapon_awp weapon_sg552 weapon_aug', 
		'MGS':'weapon_m249', 
		'NADES':'weapon_hegrenade flashbang smokegrenade', 
		'PRIMARY':'weapon_m3 weapon_xm1014 weapon_tmp weapon_mac10 weapon_mp5navy weapon_ump45 weapon_p90 weapon_galil weapon_famas weapon_ak47	weapon_scout weapon_m4a1 weapon_sg550 weapon_g3sg1 weapon_awp weapon_sg552 weapon_aug weapon_m249', 
		'SNIPERS':'weapon_scout weapon_awp weapon_g3sg1 weapon_sg550', 
		'SECONDARY':'weapon_glock weapon_usp weapon_p228 weapon_deagle weapon_fiveseven weapon_elite' }
	es.dbgmsg(0,'weapondata Configured')


	
	
	
################################################################################
#																			  #
#								WCE RANKS       						      #
#																			  #
################################################################################
def addRankExp(attacker,victim):
	steamid = getSteamid(attacker)
	exp = int(wcs.Command(victim).GetLevel())
	wcedata[steamid]['rankExp'] += exp
	breakLoop = 0
	count = 0
	if wcedata[steamid]['rankExp'] >= 200:
		if wcedata[steamid]['ranked'] != 1:
			while breakLoop == 0:
				if ranked.has_key(count):
					count += 1
				else:
					ranked[count] = {'steamid':steamid,'exp':wcedata[steamid]['rankExp']}
					wcedata[steamid]['ranked'] = 1
					es.dbgmsg(0,'New Player Now Ranked')
					breakLoop = 1
					
def updateRankExp():
	for stuff in ranked:
		ranked[stuff]['exp'] = wcedata[ranked[stuff]['steamid']]['rankExp']

def sortRanked():
	ranked.sort()



################################################################################
#																			  #
#								Item Database								 #
#								and item code								 #
#																			  #
################################################################################

def createItemDatabase():
	global wceitems
	global server
	wceitems = {}
	wceitems[1]={
	'name':'Piece Of String',
	'cashValue':50,
	'description':'Its a peice of string',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[2]={
	'name':'Piece Of String',
	'cashValue':50,
	'description':'Its a peice of string',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[3]={
	'name':'Piece Of String',
	'cashValue':50,
	'description':'Its a peice of string',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[4]={
	'name':'Piece Of String',
	'cashValue':50,
	'description':'Its a peice of string',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[5]={
	'name':'Piece Of String',
	'cashValue':50,
	'description':'Its a peice of string',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[6]={
	'name':'Piece Of String',
	'cashValue':50,
	'description':'Its a peice of string',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[7]={
	'name':'Gold Flake',
	'cashValue':3000,
	'description':'Its a Chunk of Gold',
	'usable':0,
	'rarity':1,
	'code':'0' }
	wceitems[8]={
	'name':'Old Boot',
	'cashValue':75,
	'description':'Brown Diry Boot',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[9]={
	'name':'Old Boot',
	'cashValue':75,
	'description':'Brown Diry Boot',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[10]={
	'name':'Old Boot',
	'cashValue':75,
	'description':'Brown Diry Boot',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[11]={
	'name':'Old Boot',
	'cashValue':75,
	'description':'Brown Diry Boot',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[12]={
	'name':'Piece Of Wood',
	'cashValue':20,
	'description':'Its a wooden board',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[13]={
	'name':'Piece Of Wood',
	'cashValue':20,
	'description':'Its a wooden board',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[14]={
	'name':'Piece Of Wood',
	'cashValue':20,
	'description':'Its a wooden board',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[15]={
	'name':'White Feather',
	'cashValue':100,
	'description':'Its a White Feather',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[16]={
	'name':'White Feather',
	'cashValue':100,
	'description':'Its a White Feather',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[17]={
	'name':'White Feather',
	'cashValue':100,
	'description':'Its a White Feather',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[18]={
	'name':'White Feather',
	'cashValue':100,
	'description':'Its a White Feather',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[19]={
	'name':'White Feather',
	'cashValue':100,
	'description':'Its a White Feather',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[20]={
	'name':'White Feather',
	'cashValue':100,
	'description':'Its a White Feather',
	'usable':0,
	'rarity':0,
	'code':'0' }
	wceitems[21]={
	'name':'Gold Flake',
	'cashValue':3000,
	'description':'Its a Chunk of Gold',
	'usable':0,
	'rarity':1,
	'code':'0' }
	wceitems[22]={
	'name':'Gold Flake',
	'cashValue':3000,
	'description':'Its a Chunk of Gold',
	'usable':0,
	'rarity':1,
	'code':'0' }
	wceitems[23]={
	'name':'Worn Piece Of Leather',
	'cashValue':150,
	'description':'Its all brown with scratches on the side',
	'usable':0,
	'rarity':1,
	'code':'0' }
	wceitems[23]={
	'name':'Jewel of Bless',
	'cashValue':16000,
	'description':'Gives +3 Permenent health Bonus',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).addHpBonus(3)' }
	wceitems[24]={
	'name':'Worn Piece Of Leather',
	'cashValue':150,
	'description':'Its all brown with scratches on the side',
	'usable':0,
	'rarity':1,
	'code':'0' }
	wceitems[25]={
	'name':'Worn Piece Of Leather',
	'cashValue':150,
	'description':'Its all brown with scratches on the side',
	'usable':0,
	'rarity':1,
	'code':'0' }
	wceitems[26]={
	'name':'Worn Piece Of Leather',
	'cashValue':150,
	'description':'Its all brown with scratches on the side',
	'usable':0,
	'rarity':1,
	'code':'0' }
	wceitems[27]={
	'name':'Worn Piece Of Leather',
	'cashValue':150,
	'description':'Its all brown with scratches on the side',
	'usable':0,
	'rarity':1,
	'code':'0' }
	wceitems[28]={
	'name':'Jewel of Bless',
	'cashValue':16000,
	'description':'Gives +3 Permenent health Bonus',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).addHpBonus(3)' }
	wceitems[29]={
	'name':'Energy Crystal',
	'cashValue':8000,
	'description':'Restores 50 Mana',
	'usable':1,
	'rarity':2,
	'code':'wce(userid).addMana(50)' }
	wceitems[30]={
	'name':'Energy Crystal',
	'cashValue':8000,
	'description':'Restores 50 Mana',
	'usable':1,
	'rarity':2,
	'code':'wce(userid).addMana(50)' }
	wceitems[31]={
	'name':'Energy Crystal',
	'cashValue':8000,
	'description':'Restores 50 Mana',
	'usable':1,
	'rarity':2,
	'code':'wce(userid).addMana(50)' }
	wceitems[32]={
	'name':'Energy Crystal',
	'cashValue':8000,
	'description':'Restores 50 Mana',
	'usable':1,
	'rarity':2,
	'code':'wce(userid).addMana(50)' }
	wceitems[33]={
	'name':'Mini Stupid',
	'cashValue':1000,
	'description':'You Will Find Out',
	'usable':1,
	'rarity':2,
	'code':'wce(userid).suicide()' }
	wceitems[34]={
	'name':'Potion of Invulnrability',
	'cashValue':1000,
	'description':'3 Seconds of Invulnrability',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).invuln(3)' }
	wceitems[35]={
	'name':'Potion of Invulnrability',
	'cashValue':1000,
	'description':'3 Seconds of Invulnrability',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).invuln(3)' }
	wceitems[36]={
	'name':'Potion of Invulnrability',
	'cashValue':1000,
	'description':'3 Seconds of Invulnrability',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).invuln(3)' }
	wceitems[37]={
	'name':'Potion of Invulnrability',
	'cashValue':1000,
	'description':'3 Seconds of Invulnrability',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).invuln(3)' }
	wceitems[38]={
	'name':'Potion of Invulnrability',
	'cashValue':1000,
	'description':'3 Seconds of Invulnrability',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).invuln(3)' }
	wceitems[38]={
	'name':'Potion of Invulnrability + 1',
	'cashValue':1000,
	'description':'6 Seconds of Invulnrability',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).invuln(6)' }
	wceitems[39]={
	'name':'Potion of Invulnrability + 1',
	'cashValue':1000,
	'description':'6 Seconds of Invulnrability',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).invuln(6)' }
	wceitems[40]={
	'name':'Potion of Invulnrability + 1',
	'cashValue':1000,
	'description':'6 Seconds of Invulnrability',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).invuln(6)' }
	wceitems[41]={
	'name':'Potion of Invulnrability + 2',
	'cashValue':1000,
	'description':'8 Seconds of Invulnrability',
	'usable':1,
	'rarity':3,
	'code':'wce(userid).invuln(8)' }
	wceitems[42]={
	'name':'Potion of Invulnrability + 3',
	'cashValue':1000,
	'description':'10 Seconds of Invulnrability',
	'usable':1,
	'rarity':4,
	'code':'wce(userid).invuln(10)' }
	wceitems[43]={
	'name':'Potion of Healing',
	'cashValue':1000,
	'description':'Instantly Heals 20 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(20)' }
	wceitems[44]={
	'name':'Potion of Healing',
	'cashValue':1000,
	'description':'Instantly Heals 20 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(20)' }
	wceitems[45]={
	'name':'Potion of Healing',
	'cashValue':1000,
	'description':'Instantly Heals 20 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(20)' }
	wceitems[46]={
	'name':'Potion of Healing',
	'cashValue':1000,
	'description':'Instantly Heals 20 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(20)' }
	wceitems[47]={
	'name':'Potion of Healing',
	'cashValue':1000,
	'description':'Instantly Heals 20 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(20)' }
	wceitems[48]={
	'name':'Potion of Healing',
	'cashValue':1000,
	'description':'Instantly Heals 20 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(20)' }
	wceitems[49]={
	'name':'Potion of Healing',
	'cashValue':1000,
	'description':'Instantly Heals 20 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(20)' }
	wceitems[50]={
	'name':'Potion of Healing +1',
	'cashValue':1000,
	'description':'Instantly Heals 50 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(50)' }
	wceitems[51]={
	'name':'Potion of Healing +1',
	'cashValue':2000,
	'description':'Instantly Heals 50 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(50)' }
	wceitems[52]={
	'name':'Potion of Healing +1',
	'cashValue':2000,
	'description':'Instantly Heals 50 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(50)' }
	wceitems[53]={
	'name':'Potion of Healing +1',
	'cashValue':2000,
	'description':'Instantly Heals 50 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(50)' }
	wceitems[54]={
	'name':'Potion of Healing +2',
	'cashValue':6000,
	'description':'Instantly Heals 90 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(90)' }
	wceitems[55]={
	'name':'Potion of Healing +2',
	'cashValue':6000,
	'description':'Instantly Heals 90 Health',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(90)' }
	wceitems[56]={
	'name':'Energy Crystal',
	'cashValue':8000,
	'description':'Restores 50 Mana',
	'usable':1,
	'rarity':2,
	'code':'wce(userid).addMana(50)' }
	wceitems[57]={
	'name':'Energy Crystal',
	'cashValue':8000,
	'description':'Restores 50 Mana',
	'usable':1,
	'rarity':2,
	'code':'wce(userid).addMana(50)' }
	wceitems[58]={
	'name':'Red Feather',
	'cashValue':2000,
	'description':'Feel 50% of Normal Gravity',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).SetGravity(0.5)' }
	wceitems[59]={
	'name':'Red Feather',
	'cashValue':2000,
	'description':'Feel 50% of Normal Gravity',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).SetGravity(0.5)' }
	wceitems[60]={
	'name':'Red Feather',
	'cashValue':2000,
	'description':'Feel 50% of Normal Gravity',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).SetGravity(0.5)' }
	wceitems[61]={
	'name':'Red Feather',
	'cashValue':2000,
	'description':'Feel 50% of Normal Gravity',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).SetGravity(0.5)' }
	wceitems[62]={
	'name':'Mini Grim',
	'cashValue':2000,
	'description':'Be Like Grim, But Better',
	'usable':1,
	'rarity':1,
	'code':'wce(userid).setColor(0,0,0,255)' }
	wceitems[63]={
	'name':'Mini Grim',
	'cashValue':2000,
	'description':'Be Like Grim, But Better',
	'usable':1,
	'rarity':1,
	'code':'wce(userid).setColor(0,0,0,255)' }
	wceitems[64]={
	'name':'Mini Grim',
	'cashValue':2000,
	'description':'Be Like Grim, But Better',
	'usable':1,
	'rarity':1,
	'code':'wce(userid).setColor(0,0,0,255)' }
	wceitems[65]={
	'name':'Mini Grim',
	'cashValue':2000,
	'description':'Be Like Grim, But Better',
	'usable':1,
	'rarity':1,
	'code':'wce(userid).setColor(0,0,0,255)' }
	wceitems[66]={
	'name':'Jewel of Soul',
	'cashValue':16000,
	'description':'Adds 1 To Your Max Mana',
	'usable':1,
	'rarity':4,
	'code':'wce(userid).addMaxMana(1)' }
	wceitems[67]={
	'name':'Jewel of Mind',
	'cashValue':16000,
	'description':'Adds 1 To Your Mana Regeneration',
	'usable':1,
	'rarity':4,
	'code':'wce(userid).addManaRegen(1)' }
	wceitems[68]={
	'name':'Jewel of Soul',
	'cashValue':16000,
	'description':'Adds 1 To Your Max Mana',
	'usable':1,
	'rarity':5,
	'code':'wce(userid).addMaxMana(1)' }
	wceitems[69]={
	'name':'Jewel of Mind',
	'cashValue':16000,
	'description':'Adds 1 To Your Mana Regeneration',
	'usable':1,
	'rarity':5,
	'code':'wce(userid).addManaRegen(1)' }
	wceitems[70]={
	'name':'Potion of the Turtle',
	'cashValue':2000,
	'description':'Adds 50 To Your Armor',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).ArmorAdd(50)' }
	wceitems[71]={
	'name':'Potion of the Turtle',
	'cashValue':2000,
	'description':'Adds 50 To Your Armor',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).ArmorAdd(50)' }
	wceitems[72]={
	'name':'Potion of the Turtle',
	'cashValue':2000,
	'description':'Adds 50 To Your Armor',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).ArmorAdd(50)' }
	wceitems[73]={
	'name':'Potion of the Turtle +1',
	'cashValue':4000,
	'description':'Adds 100 To Your Armor',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).ArmorAdd(100)' }
	wceitems[74]={
	'name':'Potion of the Turtle +1',
	'cashValue':4000,
	'description':'Adds 100 To Your Armor',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).ArmorAdd(100)' }
	wceitems[75]={
	'name':'Potion of the Turtle +2',
	'cashValue':6000,
	'description':'Adds 200 To Your Armor',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).ArmorAdd(200)' }
	wceitems[76]={
	'name':'Leather Belt',
	'cashValue':8000,
	'description':'lvl 18 Leather Belt, Leather Belt, 4 stam 4 streingth Leather Belt',
	'usable':0,
	'rarity':2,
	'code':'0' }
	wceitems[77]={
	'name':'Leather Belt',
	'cashValue':8000,
	'description':'lvl 18 Leather Belt, Leather Belt, 4 stam 4 streingth Leather Belt',
	'usable':0,
	'rarity':2,
	'code':'0' }
	wceitems[78]={
	'name':'Apple',
	'cashValue':3000,
	'description':'Hrmm, This tastes good',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(random.randint(1,60) )' }
	wceitems[79]={
	'name':'Apple',
	'cashValue':3000,
	'description':'Hrmm, This tastes good',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(random.randint(1,60) )' }
	wceitems[80]={
	'name':'Apple',
	'cashValue':3000,
	'description':'Hrmm, This tastes good',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).HealthAdd(random.randint(1,60) )' }
	wceitems[81]={
	'name':'Scroll of Experiance',
	'cashValue':3000,
	'description':'Gives 50 Exp',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).GiveXp(50)' }
	wceitems[82]={
	'name':'Scroll of Experiance',
	'cashValue':3000,
	'description':'Gives 50 Exp',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).GiveXp(50)' }
	wceitems[83]={
	'name':'Scroll of Experiance',
	'cashValue':3000,
	'description':'Gives 50 Exp',
	'usable':1,
	'rarity':1,
	'code':'wcs.Command(userid).GiveXp(50)' }
	wceitems[84]={
	'name':'Scroll of Experiance +1',
	'cashValue':5000,
	'description':'Gives 100 Exp',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).GiveXp(100)' }
	wceitems[85]={
	'name':'Scroll of Experiance +1',
	'cashValue':5000,
	'description':'Gives 100 Exp',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).GiveXp(100)' }
	wceitems[86]={
	'name':'Scroll of Experiance +2',
	'cashValue':8000,
	'description':'Gives 200 Exp',
	'usable':1,
	'rarity':2,
	'code':'wcs.Command(userid).GiveXp(200)' }
	wceitems[87]={
	'name':'Mini Largo Usagi',
	'cashValue':16000,
	'description':'Gives You A Level',
	'usable':1,
	'rarity':4,
	'code':'wcs.Command(userid).GiveLevel(1, "Mini Largo Usagi")' }
	wceitems[88]={
	'name':'Mini Largo Usagi',
	'cashValue':16000,
	'description':'Gives You A Level',
	'usable':1,
	'rarity':5,
	'code':'wcs.Command(userid).GiveLevel(1, "Mini Largo Usagi")' }
	wceitems[89]={
	'name':'Small Pouch',
	'cashValue':16000,
	'description':'Gives You An Extra Inventory Slot',
	'usable':1,
	'rarity':3,
	'code':'biggerBag(userid)' }
	wceitems[90]={
	'name':'Gold Coin',
	'cashValue':16000,
	'description':'Sells For A Very High Ammount',
	'usable':1,
	'rarity':2,
	'code':'0' }
	wceitems[91]={
	'name':'Gold Coin',
	'cashValue':16000,
	'description':'Sells For A Very High Ammount',
	'usable':1,
	'rarity':2,
	'code':'0' }
	wceitems[92]={
	'name':'Gold Coin',
	'cashValue':16000,
	'description':'Sells For A Very High Ammount',
	'usable':1,
	'rarity':2,
	'code':'0' }
	wceitems[93]={
	'name':'Gold Coin',
	'cashValue':16000,
	'description':'Sells For A Very High Ammount',
	'usable':1,
	'rarity':2,
	'code':'0' }
	wceitems[94]={
	'name':'Blow Up Doll',
	'cashValue':16000,
	'description':'Fun For You and Fun for... You.',
	'usable':1,
	'rarity':2,
	'code':'0' }
	wceitems[95]={
	'name':'Blow Up Doll',
	'cashValue':16000,
	'description':'Fun For You and Fun for... You.',
	'usable':1,
	'rarity':2,
	'code':'0' }
	
	
	itemCount = 0
	for item in wceitems:
		itemCount += 1
	server['variables']['itemCount'] = itemCount
	es.dbgmsg(0,'Item Database Created' )
